Index: /ccr/trunk/kids/CCD-CCR_GENERATION_UTILITIES_1P2.KID
===================================================================
--- /ccr/trunk/kids/CCD-CCR_GENERATION_UTILITIES_1P2.KID	(revision 1586)
+++ /ccr/trunk/kids/CCD-CCR_GENERATION_UTILITIES_1P2.KID	(revision 1587)
@@ -98462,1683 +98446,1735 @@
  ;
 "RTN","C0CENV",191,0)
-SAVE(OLD,NEW) ; restore routine X
+BMES(STR) ; Write BMES^XPDUTL statements
 "RTN","C0CENV",192,0)
- N %,DIE,X,XCM,XCN,XCS
+ ;
 "RTN","C0CENV",193,0)
- S DIE="^TMP($J,"""_OLD_""",",XCN=0,X=NEW
+ D BMES^XPDUTL($$CJ^XLFSTR(STR,IOM))
 "RTN","C0CENV",194,0)
- X ^%ZOSF("SAVE")
+ ;
 "RTN","C0CENV",195,0)
  Q
+"RTN","C0CENV",196,0)
+ ;
+"RTN","C0CENV",197,0)
+ ;
+"RTN","C0CENV",198,0)
+LOAD(X) ; load routine X
+"RTN","C0CENV",199,0)
+ N %N,DIF,XCNP
+"RTN","C0CENV",200,0)
+ K ^TMP($J,X)
+"RTN","C0CENV",201,0)
+ S DIF="^TMP($J,X,",XCNP=0
+"RTN","C0CENV",202,0)
+ X ^%ZOSF("LOAD")
+"RTN","C0CENV",203,0)
+ Q
+"RTN","C0CENV",204,0)
+ ;
+"RTN","C0CENV",205,0)
+ ;
+"RTN","C0CENV",206,0)
+SAVE(OLD,NEW) ; restore routine X
+"RTN","C0CENV",207,0)
+ N %,DIE,X,XCM,XCN,XCS
+"RTN","C0CENV",208,0)
+ S DIE="^TMP($J,"""_OLD_""",",XCN=0,X=NEW
+"RTN","C0CENV",209,0)
+ X ^%ZOSF("SAVE")
+"RTN","C0CENV",210,0)
+ Q
 "RTN","C0CEVC")
-0^76^B18388545
+0^76^B21455969
 "RTN","C0CEVC",1,0)
 C0CEVC   ; CCDCCR/GPL - SUPPORT FOR EWD VISTCOM PAGES ; 3/1/2010
 "RTN","C0CEVC",2,0)
- ;;1.2;C0C;;May 11, 2012;Build 50
+ ;;1.2;CCD/CCR GENERATION UTILITIES;;Oct 30, 2012;Build 51
 "RTN","C0CEVC",3,0)
+ ;
+"RTN","C0CEVC",4,0)
+ ; (C) Geroge Lilly 2010.
+"RTN","C0CEVC",5,0)
+ ;
+"RTN","C0CEVC",6,0)
+ ; This program is free software: you can redistribute it and/or modify
+"RTN","C0CEVC",7,0)
+ ; it under the terms of the GNU Affero General Public License as
+"RTN","C0CEVC",8,0)
+ ; published by the Free Software Foundation, either version 3 of the
+"RTN","C0CEVC",9,0)
+ ; License, or (at your option) any later version.
+"RTN","C0CEVC",10,0)
+ ;
+"RTN","C0CEVC",11,0)
+ ; This program is distributed in the hope that it will be useful,
+"RTN","C0CEVC",12,0)
+ ; but WITHOUT ANY WARRANTY; without even the implied warranty of
+"RTN","C0CEVC",13,0)
+ ; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+"RTN","C0CEVC",14,0)
+ ; GNU Affero General Public License for more details.
+"RTN","C0CEVC",15,0)
+ ;
+"RTN","C0CEVC",16,0)
+ ; You should have received a copy of the GNU Affero General Public License
+"RTN","C0CEVC",17,0)
+ ; along with this program.  If not, see <http://www.gnu.org/licenses/>.
+"RTN","C0CEVC",18,0)
+ ;
+"RTN","C0CEVC",19,0)
 gpltest2 ; experiment with sending a CCR to an ewd page
-"RTN","C0CEVC",4,0)
+"RTN","C0CEVC",20,0)
  N ZI
-"RTN","C0CEVC",5,0)
+"RTN","C0CEVC",21,0)
  S ZI=""
-"RTN","C0CEVC",6,0)
+"RTN","C0CEVC",22,0)
  D PSEUDO
-"RTN","C0CEVC",7,0)
+"RTN","C0CEVC",23,0)
  N ZIO
-"RTN","C0CEVC",8,0)
+"RTN","C0CEVC",24,0)
  S ZIO=IO
-"RTN","C0CEVC",9,0)
+"RTN","C0CEVC",25,0)
  S IO="/dev/null"
-"RTN","C0CEVC",10,0)
+"RTN","C0CEVC",26,0)
  OPEN IO
-"RTN","C0CEVC",11,0)
+"RTN","C0CEVC",27,0)
  U IO
-"RTN","C0CEVC",12,0)
+"RTN","C0CEVC",28,0)
  N G
-"RTN","C0CEVC",13,0)
+"RTN","C0CEVC",29,0)
  S G=$$URLTOKEN^C0CEWD
-"RTN","C0CEVC",14,0)
+"RTN","C0CEVC",30,0)
  D CCRRPC^C0CCCR(.GPL,2)
-"RTN","C0CEVC",15,0)
+"RTN","C0CEVC",31,0)
  S IO=ZIO
-"RTN","C0CEVC",16,0)
+"RTN","C0CEVC",32,0)
  OPEN IO
-"RTN","C0CEVC",17,0)
+"RTN","C0CEVC",33,0)
  U IO
-"RTN","C0CEVC",18,0)
+"RTN","C0CEVC",34,0)
  K GPL(0)
-"RTN","C0CEVC",19,0)
+"RTN","C0CEVC",35,0)
  F  S ZI=$O(GPL(ZI)) Q:ZI=""  W GPL(ZI),!
-"RTN","C0CEVC",20,0)
+"RTN","C0CEVC",36,0)
  Q
-"RTN","C0CEVC",21,0)
- ;
-"RTN","C0CEVC",22,0)
+"RTN","C0CEVC",37,0)
+ ;
+"RTN","C0CEVC",38,0)
 gpltest ; experiment with sending a CCR to an ewd page
-"RTN","C0CEVC",23,0)
+"RTN","C0CEVC",39,0)
  N ZI
-"RTN","C0CEVC",24,0)
+"RTN","C0CEVC",40,0)
  S ZI=""
-"RTN","C0CEVC",25,0)
+"RTN","C0CEVC",41,0)
  K ^GPL(0)
-"RTN","C0CEVC",26,0)
+"RTN","C0CEVC",42,0)
  S ^GPL(2)="<?xml-stylesheet type=""text/xsl"" href=""/resources/ccr.xsl""?>"
-"RTN","C0CEVC",27,0)
+"RTN","C0CEVC",43,0)
  F  S ZI=$O(^GPL(ZI)) Q:ZI=""  W ^GPL(ZI),!
-"RTN","C0CEVC",28,0)
+"RTN","C0CEVC",44,0)
  Q
-"RTN","C0CEVC",29,0)
- ;
-"RTN","C0CEVC",30,0)
+"RTN","C0CEVC",45,0)
+ ;
+"RTN","C0CEVC",46,0)
 TEST(sessid); 
-"RTN","C0CEVC",31,0)
+"RTN","C0CEVC",47,0)
  d setSessionValue^%zewdAPI("person.Name","Rob",sessid)
-"RTN","C0CEVC",32,0)
+"RTN","C0CEVC",48,0)
  d setSessionValue^%zewdAPI("person.DateOfBirth","13/06/55",sessid)
-"RTN","C0CEVC",33,0)
+"RTN","C0CEVC",49,0)
  d setSessionValue^%zewdAPI("person.Address.PostCode","SW1 3QA",sessid)
-"RTN","C0CEVC",34,0)
+"RTN","C0CEVC",50,0)
  d setSessionValue^%zewdAPI("person.Address.Line1","1 The Street",sessid)
-"RTN","C0CEVC",35,0)
+"RTN","C0CEVC",51,0)
  d setSessionValue^%zewdAPI("person.Address.2.hello","world",sessid)
-"RTN","C0CEVC",36,0)
+"RTN","C0CEVC",52,0)
  d setJSONValue^%zewdAPI("json","person",sessid)
-"RTN","C0CEVC",37,0)
+"RTN","C0CEVC",53,0)
  Q ""
-"RTN","C0CEVC",38,0)
+"RTN","C0CEVC",54,0)
  
-"RTN","C0CEVC",39,0)
+"RTN","C0CEVC",55,0)
 PARSE(INXML,INDOC) ;CALL THE EWD PARSER ON INXML, PASSED BY NAME
-"RTN","C0CEVC",40,0)
+"RTN","C0CEVC",56,0)
  ; INDOC IS PASSED AS THE DOCUMENT NAME TO EWD
-"RTN","C0CEVC",41,0)
+"RTN","C0CEVC",57,0)
  ; EXTRINSIC WHICH RETURNS THE DOCID ASSIGNED BY EWD
-"RTN","C0CEVC",42,0)
+"RTN","C0CEVC",58,0)
  N ZR
-"RTN","C0CEVC",43,0)
+"RTN","C0CEVC",59,0)
  M ^CacheTempEWD($j)=@INXML ;
-"RTN","C0CEVC",44,0)
+"RTN","C0CEVC",60,0)
  S ZR=$$parseDocument^%zewdHTMLParser(INDOC)
-"RTN","C0CEVC",45,0)
+"RTN","C0CEVC",61,0)
  Q ZR
-"RTN","C0CEVC",46,0)
- ;
-"RTN","C0CEVC",47,0)
+"RTN","C0CEVC",62,0)
+ ;
+"RTN","C0CEVC",63,0)
 TEST2(sessid) ; try to put a ccr in the session
-"RTN","C0CEVC",48,0)
+"RTN","C0CEVC",64,0)
  S U="^"
-"RTN","C0CEVC",49,0)
+"RTN","C0CEVC",65,0)
  D PSEUDO ; FAKE LOGIN
-"RTN","C0CEVC",50,0)
+"RTN","C0CEVC",66,0)
  S ZIO=$IO
-"RTN","C0CEVC",51,0)
+"RTN","C0CEVC",67,0)
  S DEV="/dev/null"
-"RTN","C0CEVC",52,0)
+"RTN","C0CEVC",68,0)
  O DEV U DEV
-"RTN","C0CEVC",53,0)
+"RTN","C0CEVC",69,0)
  N G
-"RTN","C0CEVC",54,0)
+"RTN","C0CEVC",70,0)
  N ZDFN
-"RTN","C0CEVC",55,0)
+"RTN","C0CEVC",71,0)
  S ZDFN=$$getSessionValue^%zewdAPI("vista.dfn",sessid)
-"RTN","C0CEVC",56,0)
+"RTN","C0CEVC",72,0)
  I ZDFN="" S ZDFN=2
-"RTN","C0CEVC",57,0)
+"RTN","C0CEVC",73,0)
  ;K ^TMP("GPL")
-"RTN","C0CEVC",58,0)
+"RTN","C0CEVC",74,0)
  ;M ^TMP("GPL")=^%zewdSession("session",sessid)
-"RTN","C0CEVC",59,0)
+"RTN","C0CEVC",75,0)
  D CCRRPC^C0CCCR(.GPL,ZDFN)
-"RTN","C0CEVC",60,0)
+"RTN","C0CEVC",76,0)
  K GPL(0)   
-"RTN","C0CEVC",61,0)
+"RTN","C0CEVC",77,0)
  S GPL(2)="<?xml-stylesheet type=""text/xsl"" href=""/resources/ccr.xsl""?>"
-"RTN","C0CEVC",62,0)
+"RTN","C0CEVC",78,0)
  C DEV U ZIO
-"RTN","C0CEVC",63,0)
+"RTN","C0CEVC",79,0)
  ;M ^CacheTempEWD($j)=GPL
-"RTN","C0CEVC",64,0)
+"RTN","C0CEVC",80,0)
  S DOCNAME="CCR"
-"RTN","C0CEVC",65,0)
+"RTN","C0CEVC",81,0)
  ;ZWR GPL 
-"RTN","C0CEVC",66,0)
+"RTN","C0CEVC",82,0)
  ;S ZR=$$parseDocument^%zewdHTMLParser(DOCNAME)
-"RTN","C0CEVC",67,0)
+"RTN","C0CEVC",83,0)
  ;d setSessionValues^%zewdAPI(DOCNAME,GPL,sessid)
-"RTN","C0CEVC",68,0)
+"RTN","C0CEVC",84,0)
  d mergeArrayToSession^%zewdAPI(.GPL,DOCNAME,sessid)
-"RTN","C0CEVC",69,0)
+"RTN","C0CEVC",85,0)
  Q ""
-"RTN","C0CEVC",70,0)
- ;
-"RTN","C0CEVC",71,0)
+"RTN","C0CEVC",86,0)
+ ;
+"RTN","C0CEVC",87,0)
 INITSES(sessid) ;initialize an EWD/CPRS session
-"RTN","C0CEVC",72,0)
+"RTN","C0CEVC",88,0)
  K ^TMP("GPL")
-"RTN","C0CEVC",73,0)
+"RTN","C0CEVC",89,0)
  ;M ^TMP("GPL")=^%zewdSession("session",sessid)
-"RTN","C0CEVC",74,0)
+"RTN","C0CEVC",90,0)
  N ZT,ZDFN
-"RTN","C0CEVC",75,0)
+"RTN","C0CEVC",91,0)
  S ZT=$$URLTOKEN^C0CEWD(sessid)
-"RTN","C0CEVC",76,0)
+"RTN","C0CEVC",92,0)
  ;S ^TMP("GPL")=ZT
-"RTN","C0CEVC",77,0)
+"RTN","C0CEVC",93,0)
  d trace^%zewdAPI("*********************ZT="_ZT)
-"RTN","C0CEVC",78,0)
+"RTN","C0CEVC",94,0)
  S ZDFN=$$PRSEORTK(ZT) ; PARSE THE TOKEN AND LOOK UP THE DFN
-"RTN","C0CEVC",79,0)
+"RTN","C0CEVC",95,0)
  S ^TMP("GPL","DFN")=ZDFN
-"RTN","C0CEVC",80,0)
+"RTN","C0CEVC",96,0)
  I ZDFN=0 S DFN=2 ; DEFAULT TEST PATIENT
-"RTN","C0CEVC",81,0)
+"RTN","C0CEVC",97,0)
  D setSessionValue^%zewdAPI("vista.dfn",ZDFN,sessid)
-"RTN","C0CEVC",82,0)
+"RTN","C0CEVC",98,0)
  ;M ^TMP("GPL","request")=requestArray
-"RTN","C0CEVC",83,0)
+"RTN","C0CEVC",99,0)
  ;D PSEUDO
-"RTN","C0CEVC",84,0)
+"RTN","C0CEVC",100,0)
  ;D ^%ZTER
-"RTN","C0CEVC",85,0)
+"RTN","C0CEVC",101,0)
  q ""
-"RTN","C0CEVC",86,0)
- ;
-"RTN","C0CEVC",87,0)
+"RTN","C0CEVC",102,0)
+ ;
+"RTN","C0CEVC",103,0)
 PRSEORTK(ZTOKEN) ;PARSES THE TOKEN SENT BY CPRS AND RETURNS THE DFN 
-"RTN","C0CEVC",88,0)
+"RTN","C0CEVC",104,0)
  ; OF THE PATIENT ; HERE'S WHAT THE TOKEN LOOKS LIKE: 
-"RTN","C0CEVC",89,0)
+"RTN","C0CEVC",105,0)
  ; ^TMP('ORWCHART',6547,'192.168.169.8',002E0FE6)
-"RTN","C0CEVC",90,0)
+"RTN","C0CEVC",106,0)
  N ZX,ZN1,ZIP,ZN2,ZDFN,ZG
-"RTN","C0CEVC",91,0)
+"RTN","C0CEVC",107,0)
  S ZDFN=0 ; DEFAULT RETURN
-"RTN","C0CEVC",92,0)
+"RTN","C0CEVC",108,0)
  S ZN1=$P(ZTOKEN,",",2) ; FIRST NUMBER
-"RTN","C0CEVC",93,0)
+"RTN","C0CEVC",109,0)
  S ZIP=$P(ZTOKEN,",",3) ; IP NUMBER
-"RTN","C0CEVC",94,0)
+"RTN","C0CEVC",110,0)
  S ZIP=$P(ZIP,"'",2) ; GET RID OF '
-"RTN","C0CEVC",95,0)
+"RTN","C0CEVC",111,0)
  S ZN2=$P(ZTOKEN,",",4) ; SECOND NUMBER
-"RTN","C0CEVC",96,0)
+"RTN","C0CEVC",112,0)
  S ZN2=$P(ZN2,")",1) ; GET RID OF )
-"RTN","C0CEVC",97,0)
+"RTN","C0CEVC",113,0)
  S ZG=$NA(^TMP("ORWCHART",ZN1,ZIP,ZN2)) ; BUILD THE GLOBAL NAME
-"RTN","C0CEVC",98,0)
+"RTN","C0CEVC",114,0)
  I $G(@ZG)'="" S ZDFN=@ZG ; ACCESS THE GLOBAL
-"RTN","C0CEVC",99,0)
+"RTN","C0CEVC",115,0)
  S ^TMP("GPL","FIRSTDFN")=ZDFN
-"RTN","C0CEVC",100,0)
+"RTN","C0CEVC",116,0)
  S ^TMP("GPL","FIRSTGLB")=ZG
-"RTN","C0CEVC",101,0)
+"RTN","C0CEVC",117,0)
  Q ZDFN
-"RTN","C0CEVC",102,0)
- ;
-"RTN","C0CEVC",103,0)
+"RTN","C0CEVC",118,0)
+ ;
+"RTN","C0CEVC",119,0)
 GETPATIENTLIST(sessid) ;
-"RTN","C0CEVC",104,0)
+"RTN","C0CEVC",120,0)
  D PSEUDO
-"RTN","C0CEVC",105,0)
+"RTN","C0CEVC",121,0)
  D LISTALL^ORWPT(.RTN,"NAME","1")
-"RTN","C0CEVC",106,0)
+"RTN","C0CEVC",122,0)
  N ZI
-"RTN","C0CEVC",107,0)
+"RTN","C0CEVC",123,0)
  S ZI=""
-"RTN","C0CEVC",108,0)
+"RTN","C0CEVC",124,0)
  F  S ZI=$O(RTN(ZI)) Q:ZI=""  D  ;
-"RTN","C0CEVC",109,0)
+"RTN","C0CEVC",125,0)
  . S data(ZI,"DFN")=$P(RTN(ZI),"^",1)
-"RTN","C0CEVC",110,0)
+"RTN","C0CEVC",126,0)
  . S data(ZI,"Name")=$P(RTN(ZI),"^",2)
-"RTN","C0CEVC",111,0)
+"RTN","C0CEVC",127,0)
  ; ZWR data
-"RTN","C0CEVC",112,0)
+"RTN","C0CEVC",128,0)
  ;S data(1,"DFN")=$P(RTN(1),"^",1)
-"RTN","C0CEVC",113,0)
+"RTN","C0CEVC",129,0)
  ;S data(1,"Name")=$P(RTN(1),"^",2)
-"RTN","C0CEVC",114,0)
+"RTN","C0CEVC",130,0)
  d deleteFromSession^%zewdAPI("patients",sessid)
-"RTN","C0CEVC",115,0)
+"RTN","C0CEVC",131,0)
  d createDataTableStore^%zewdYUIRuntime(.data,"patients",sessid)
-"RTN","C0CEVC",116,0)
+"RTN","C0CEVC",132,0)
  ;d mergeArrayToSession^%zewdAPI(.data,"patients",sessid)
-"RTN","C0CEVC",117,0)
+"RTN","C0CEVC",133,0)
  Q ""
-"RTN","C0CEVC",118,0)
- ;
-"RTN","C0CEVC",119,0)
+"RTN","C0CEVC",134,0)
+ ;
+"RTN","C0CEVC",135,0)
 PSEUDO 
-"RTN","C0CEVC",120,0)
+"RTN","C0CEVC",136,0)
  S U="^"
-"RTN","C0CEVC",121,0)
+"RTN","C0CEVC",137,0)
  S DILOCKTM=3
-"RTN","C0CEVC",122,0)
+"RTN","C0CEVC",138,0)
  S DISYS=19
-"RTN","C0CEVC",123,0)
+"RTN","C0CEVC",139,0)
  S DT=3100219
-"RTN","C0CEVC",124,0)
+"RTN","C0CEVC",140,0)
  S DTIME=999
-"RTN","C0CEVC",125,0)
+"RTN","C0CEVC",141,0)
  S DUZ=10
-"RTN","C0CEVC",126,0)
+"RTN","C0CEVC",142,0)
  S DUZ(0)="@"
-"RTN","C0CEVC",127,0)
+"RTN","C0CEVC",143,0)
  S DUZ(1)=""
-"RTN","C0CEVC",128,0)
+"RTN","C0CEVC",144,0)
  S DUZ(2)=1
-"RTN","C0CEVC",129,0)
+"RTN","C0CEVC",145,0)
  S DUZ("AG")="V"
-"RTN","C0CEVC",130,0)
+"RTN","C0CEVC",146,0)
  S DUZ("BUF")=1
-"RTN","C0CEVC",131,0)
+"RTN","C0CEVC",147,0)
  S DUZ("LANG")=""
-"RTN","C0CEVC",132,0)
+"RTN","C0CEVC",148,0)
  ;S IO="/dev/pts/2"
-"RTN","C0CEVC",133,0)
+"RTN","C0CEVC",149,0)
  ;S IO(0)="/dev/pts/2"
-"RTN","C0CEVC",134,0)
+"RTN","C0CEVC",150,0)
  ;S IO(1,"/dev/pts/2")=""
-"RTN","C0CEVC",135,0)
+"RTN","C0CEVC",151,0)
  ;S IO("ERROR")=""
-"RTN","C0CEVC",136,0)
+"RTN","C0CEVC",152,0)
  ;S IO("HOME")="41^/dev/pts/2"
-"RTN","C0CEVC",137,0)
+"RTN","C0CEVC",153,0)
  ;S IO("ZIO")="/dev/pts/2"
-"RTN","C0CEVC",138,0)
+"RTN","C0CEVC",154,0)
  ;S IOBS="$C(8)"
-"RTN","C0CEVC",139,0)
+"RTN","C0CEVC",155,0)
  ;S IOF="#,$C(27,91,50,74,27,91,72)"
-"RTN","C0CEVC",140,0)
+"RTN","C0CEVC",156,0)
  ;S SIOM=80
-"RTN","C0CEVC",141,0)
+"RTN","C0CEVC",157,0)
  Q
-"RTN","C0CEVC",142,0)
- ;
-"RTN","C0CEVC",143,0)
+"RTN","C0CEVC",158,0)
+ ;
+"RTN","C0CEVC",159,0)
 PSEUDO2 ; FAKE LOGIN SETS SOME LOCAL VARIABLE TO FOOL FILEMAN
-"RTN","C0CEVC",144,0)
+"RTN","C0CEVC",160,0)
  S DILOCKTM=3
-"RTN","C0CEVC",145,0)
+"RTN","C0CEVC",161,0)
  S DISYS=19
-"RTN","C0CEVC",146,0)
+"RTN","C0CEVC",162,0)
  S DT=3100112
-"RTN","C0CEVC",147,0)
+"RTN","C0CEVC",163,0)
  S DTIME=9999
-"RTN","C0CEVC",148,0)
+"RTN","C0CEVC",164,0)
  S DUZ=10000000020
-"RTN","C0CEVC",149,0)
+"RTN","C0CEVC",165,0)
  S DUZ(0)="@"
-"RTN","C0CEVC",150,0)
+"RTN","C0CEVC",166,0)
  S DUZ(1)=""
-"RTN","C0CEVC",151,0)
+"RTN","C0CEVC",167,0)
  S DUZ(2)=67
-"RTN","C0CEVC",152,0)
+"RTN","C0CEVC",168,0)
  S DUZ("AG")="E"
-"RTN","C0CEVC",153,0)
+"RTN","C0CEVC",169,0)
  S DUZ("BUF")=1
-"RTN","C0CEVC",154,0)
+"RTN","C0CEVC",170,0)
  S DUZ("LANG")=1
-"RTN","C0CEVC",155,0)
+"RTN","C0CEVC",171,0)
  S IO="/dev/pts/0"
-"RTN","C0CEVC",156,0)
+"RTN","C0CEVC",172,0)
  ;S IO(0)="/dev/pts/0"
-"RTN","C0CEVC",157,0)
+"RTN","C0CEVC",173,0)
  ;S IO(1,"/dev/pts/0")=""
-"RTN","C0CEVC",158,0)
+"RTN","C0CEVC",174,0)
  ;S IO("ERROR")=""
-"RTN","C0CEVC",159,0)
+"RTN","C0CEVC",175,0)
  ;S IO("HOME")="50^/dev/pts/0"
-"RTN","C0CEVC",160,0)
+"RTN","C0CEVC",176,0)
  ;S IO("ZIO")="/dev/pts/0"
-"RTN","C0CEVC",161,0)
+"RTN","C0CEVC",177,0)
  ;S IOBS="$C(8)"
-"RTN","C0CEVC",162,0)
+"RTN","C0CEVC",178,0)
  ;S IOF="!!!!!!!!!!!!!!!!!!!!!!!!,#,$C(27,91,50,74,27,91,72)"
-"RTN","C0CEVC",163,0)
+"RTN","C0CEVC",179,0)
  ;S IOM=80
-"RTN","C0CEVC",164,0)
+"RTN","C0CEVC",180,0)
  ;S ION="GTM/UNIX TELNET"
-"RTN","C0CEVC",165,0)
+"RTN","C0CEVC",181,0)
  ;S IOS=50
-"RTN","C0CEVC",166,0)
+"RTN","C0CEVC",182,0)
  ;S IOSL=24
-"RTN","C0CEVC",167,0)
+"RTN","C0CEVC",183,0)
  ;S IOST="C-VT100"
-"RTN","C0CEVC",168,0)
+"RTN","C0CEVC",184,0)
  ;S IOST(0)=9
-"RTN","C0CEVC",169,0)
+"RTN","C0CEVC",185,0)
  ;S IOT="VTRM"
-"RTN","C0CEVC",170,0)
+"RTN","C0CEVC",186,0)
  ;S IOXY="W $C(27,91)_((DY+1))_$C(59)_((DX+1))_$C(72)"
-"RTN","C0CEVC",171,0)
+"RTN","C0CEVC",187,0)
  S U="^"
-"RTN","C0CEVC",172,0)
+"RTN","C0CEVC",188,0)
  S X="1;DIC(4.2,"
-"RTN","C0CEVC",173,0)
+"RTN","C0CEVC",189,0)
  S XPARSYS="1;DIC(4.2,"
-"RTN","C0CEVC",174,0)
+"RTN","C0CEVC",190,0)
  S XQXFLG="^^XUP"
-"RTN","C0CEVC",175,0)
+"RTN","C0CEVC",191,0)
  S Y="DEV^VISTA^hollywood^VISTA:hollywood"
-"RTN","C0CEVC",176,0)
+"RTN","C0CEVC",192,0)
  Q
-"RTN","C0CEVC",177,0)
+"RTN","C0CEVC",193,0)
  ;
 "RTN","C0CEWD")
-0^77^B5607678
+0^77^B5530676
 "RTN","C0CEWD",1,0)
 C0CEWD   ; CCDCCR/GPL - CCR EWD utilities; 1/6/11
 "RTN","C0CEWD",2,0)
- ;;1.2;C0C;;May 11, 2012;Build 50
+ ;;1.2;CCD/CCR GENERATION UTILITIES;;Oct 30, 2012;Build 51
 "RTN","C0CEWD",3,0)
- ;Copyright 2011 George Lilly.  Licensed under the terms of the GNU
+ ;
 "RTN","C0CEWD",4,0)
- ;General Public License See attached copy of the License.
+ ;Copyright 2011 George Lilly.  
 "RTN","C0CEWD",5,0)
  ;
 "RTN","C0CEWD",6,0)
- ;This program is free software; you can redistribute it and/or modify
+ ; This program is free software: you can redistribute it and/or modify
 "RTN","C0CEWD",7,0)
- ;it under the terms of the GNU General Public License as published by
+ ; it under the terms of the GNU Affero General Public License as
 "RTN","C0CEWD",8,0)
- ;the Free Software Foundation; either version 2 of the License, or
+ ; published by the Free Software Foundation, either version 3 of the
 "RTN","C0CEWD",9,0)
- ;(at your option) any later version.
+ ; License, or (at your option) any later version.
 "RTN","C0CEWD",10,0)
  ;
 "RTN","C0CEWD",11,0)
- ;This program is distributed in the hope that it will be useful,
+ ; This program is distributed in the hope that it will be useful,
 "RTN","C0CEWD",12,0)
- ;but WITHOUT ANY WARRANTY; without even the implied warranty of
+ ; but WITHOUT ANY WARRANTY; without even the implied warranty of
 "RTN","C0CEWD",13,0)
- ;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ ; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 "RTN","C0CEWD",14,0)
- ;GNU General Public License for more details.
+ ; GNU Affero General Public License for more details.
 "RTN","C0CEWD",15,0)
  ;
 "RTN","C0CEWD",16,0)
- ;You should have received a copy of the GNU General Public License along
+ ; You should have received a copy of the GNU Affero General Public License
 "RTN","C0CEWD",17,0)
- ;with this program; if not, write to the Free Software Foundation, Inc.,
+ ; along with this program.  If not, see <http://www.gnu.org/licenses/>.
 "RTN","C0CEWD",18,0)
- ;51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+ ;
 "RTN","C0CEWD",19,0)
- ;
+ Q
 "RTN","C0CEWD",20,0)
+ ;
+"RTN","C0CEWD",21,0)
+TOKEN() ; EXTRINSIC WHICH RETURNS A NEW RANDOM TOKEN
+"RTN","C0CEWD",22,0)
+ Q $$UUID^C0CUTIL ; USE THE UUID FUNCTION IN THE CCR PACKAGE
+"RTN","C0CEWD",23,0)
+ ;
+"RTN","C0CEWD",24,0)
+STORE(ZARY) ; STORE AN ARRAY OF VALUES INDEXED BY A NEW TOKEN
+"RTN","C0CEWD",25,0)
+ ; IN ^TMP("C0E","TOKEN") FOR LATER RETRIEVAL FROM INSIDE AN EWD SESSION
+"RTN","C0CEWD",26,0)
+ ; RETURNS THE TOKEN. ZARY IS PASSED BY NAME
+"RTN","C0CEWD",27,0)
+ N ZT
+"RTN","C0CEWD",28,0)
+ S ZT=$$TOKEN ; GET A NEW TOKEN
+"RTN","C0CEWD",29,0)
+ M ^TMP("C0E","TOKEN",ZT)=@ZARY ;
+"RTN","C0CEWD",30,0)
+ Q ZT
+"RTN","C0CEWD",31,0)
+ ;
+"RTN","C0CEWD",32,0)
+GET(C0ERTN,C0ETOKEN,NOKILL) ; RETRIEVE A STORED ARRAY INDEXED BY ZTOKEN
+"RTN","C0CEWD",33,0)
+ ; KILL THE ARRAY AFTER RETRIEVAL UNLESS NOKILL=1
+"RTN","C0CEWD",34,0)
+ ; C0ERTN IS PASSED BY NAME
+"RTN","C0CEWD",35,0)
+ I '$D(^TMP("C0E","TOKEN",C0ETOKEN)) D  Q  ; DOESN'T EXIST
+"RTN","C0CEWD",36,0)
+ . S @C0ERTN="" ; PASS BACK NULL
+"RTN","C0CEWD",37,0)
+ M @C0ERTN=^TMP("C0E","TOKEN",C0ETOKEN) ; RETRIEVE
+"RTN","C0CEWD",38,0)
+ I $G(NOKILL)'=1 K ^TMP("C0E","TOKEN",C0ETOKEN) ; DELETE
+"RTN","C0CEWD",39,0)
  Q
-"RTN","C0CEWD",21,0)
- ;
-"RTN","C0CEWD",22,0)
-TOKEN() ; EXTRINSIC WHICH RETURNS A NEW RANDOM TOKEN
-"RTN","C0CEWD",23,0)
- Q $$UUID^C0CUTIL ; USE THE UUID FUNCTION IN THE CCR PACKAGE
-"RTN","C0CEWD",24,0)
- ;
-"RTN","C0CEWD",25,0)
-STORE(ZARY) ; STORE AN ARRAY OF VALUES INDEXED BY A NEW TOKEN
-"RTN","C0CEWD",26,0)
- ; IN ^TMP("C0E","TOKEN") FOR LATER RETRIEVAL FROM INSIDE AN EWD SESSION
-"RTN","C0CEWD",27,0)
- ; RETURNS THE TOKEN. ZARY IS PASSED BY NAME
-"RTN","C0CEWD",28,0)
- N ZT
-"RTN","C0CEWD",29,0)
- S ZT=$$TOKEN ; GET A NEW TOKEN
-"RTN","C0CEWD",30,0)
- M ^TMP("C0E","TOKEN",ZT)=@ZARY ;
-"RTN","C0CEWD",31,0)
- Q ZT
-"RTN","C0CEWD",32,0)
- ;
-"RTN","C0CEWD",33,0)
-GET(C0ERTN,C0ETOKEN,NOKILL) ; RETRIEVE A STORED ARRAY INDEXED BY ZTOKEN
-"RTN","C0CEWD",34,0)
- ; KILL THE ARRAY AFTER RETRIEVAL UNLESS NOKILL=1
-"RTN","C0CEWD",35,0)
- ; C0ERTN IS PASSED BY NAME
-"RTN","C0CEWD",36,0)
- I '$D(^TMP("C0E","TOKEN",C0ETOKEN)) D  Q  ; DOESN'T EXIST
-"RTN","C0CEWD",37,0)
- . S @C0ERTN="" ; PASS BACK NULL
-"RTN","C0CEWD",38,0)
- M @C0ERTN=^TMP("C0E","TOKEN",C0ETOKEN) ; RETRIEVE
-"RTN","C0CEWD",39,0)
- I $G(NOKILL)'=1 K ^TMP("C0E","TOKEN",C0ETOKEN) ; DELETE
 "RTN","C0CEWD",40,0)
- Q
+ ;
 "RTN","C0CEWD",41,0)
- ;
+URLTOKEN(sessid) ; EXTRINSIC WHICH RETRIEVES THE TOKEN PASSED ON THE URL
 "RTN","C0CEWD",42,0)
-URLTOKEN(sessid) ; EXTRINSIC WHICH RETRIEVES THE TOKEN PASSED ON THE URL
+ ; IN EWD EXAMPLE: https://example.com/ewd/myApp/index.ewd?token="12345"
 "RTN","C0CEWD",43,0)
- ; IN EWD EXAMPLE: https://example.com/ewd/myApp/index.ewd?token="12345"
+ N token
 "RTN","C0CEWD",44,0)
- N token
+ S token=""
 "RTN","C0CEWD",45,0)
- S token=""
+ s token=$$getRequestValue^%zewdAPI("token",sessid)
 "RTN","C0CEWD",46,0)
- s token=$$getRequestValue^%zewdAPI("token",sessid)
+ s token=$tr(token,"""") ; strip out quotes
 "RTN","C0CEWD",47,0)
- s token=$tr(token,"""") ; strip out quotes
+ Q token
 "RTN","C0CEWD",48,0)
- Q token
+ ;
 "RTN","C0CEWD",49,0)
- ;
+cbTestMethod(prefix,seedValue,lastSeedValue,optionNo,options) 
 "RTN","C0CEWD",50,0)
-cbTestMethod(prefix,seedValue,lastSeedValue,optionNo,options) 
+ ;
 "RTN","C0CEWD",51,0)
- ;
+ n maxNo,noFound
 "RTN","C0CEWD",52,0)
- n maxNo,noFound
+ ;
 "RTN","C0CEWD",53,0)
- ;
+ s maxNo=50
 "RTN","C0CEWD",54,0)
- s maxNo=50
+ s noFound=0
 "RTN","C0CEWD",55,0)
- s noFound=0
+ f  s seedValue=$o(^DPT("B",seedValue)) q:seedValue=""  q:noFound=maxNo  d
 "RTN","C0CEWD",56,0)
- f  s seedValue=$o(^DPT("B",seedValue)) q:seedValue=""  q:noFound=maxNo  d
+ . s lastSeedValue=seedValue
 "RTN","C0CEWD",57,0)
- . s lastSeedValue=seedValue
+ . i prefix'="",$e(seedValue,1,$l(prefix))'=prefix q
 "RTN","C0CEWD",58,0)
- . i prefix'="",$e(seedValue,1,$l(prefix))'=prefix q
+ . s optionNo=optionNo+1
 "RTN","C0CEWD",59,0)
- . s optionNo=optionNo+1
+ . s noFound=noFound+1
 "RTN","C0CEWD",60,0)
- . s noFound=noFound+1
+ . s options(optionNo)=seedValue
 "RTN","C0CEWD",61,0)
- . s options(optionNo)=seedValue
+ QUIT
 "RTN","C0CEWD",62,0)
- QUIT
+ ;
 "RTN","C0CEWD",63,0)
- ;
+set1 ;
 "RTN","C0CEWD",64,0)
-set1 ;
+ s ^zewd("comboPlus","methodMap","test")="cbTestMethod^C0PEREW"
 "RTN","C0CEWD",65,0)
- s ^zewd("comboPlus","methodMap","test")="cbTestMethod^C0PEREW"
+ q
 "RTN","C0CEWD",66,0)
- q
+ ;
 "RTN","C0CEWD",67,0)
- ;
+test1(sessid) ;
 "RTN","C0CEWD",68,0)
-test1(sessid) ;
+ d setSessionValue^%zewdAPI("testing","ZZ",sessid)
 "RTN","C0CEWD",69,0)
- d setSessionValue^%zewdAPI("testing","ZZ",sessid)
+ q 0
 "RTN","C0CEWD",70,0)
- q 0
-"RTN","C0CEWD",71,0)
  ;
 "RTN","C0CEWD1")
-0^78^B6563070
+0^78^B6276162
 "RTN","C0CEWD1",1,0)
 C0CEWD1   ; CCDCCR/GPL - CCR FILEMAN utilities; 12/6/08
 "RTN","C0CEWD1",2,0)
- ;;1.2;C0C;;May 11, 2012;Build 50
+ ;;1.2;CCD/CCR GENERATION UTILITIES;;Oct 30, 2012;Build 51
 "RTN","C0CEWD1",3,0)
- ;Copyright 2009 George Lilly.  Licensed under the terms of the GNU
+ ;
 "RTN","C0CEWD1",4,0)
- ;General Public License See attached copy of the License.
+ ; This program is free software: you can redistribute it and/or modify
 "RTN","C0CEWD1",5,0)
- ;
+ ; it under the terms of the GNU Affero General Public License as
 "RTN","C0CEWD1",6,0)
- ;This program is free software; you can redistribute it and/or modify
+ ; published by the Free Software Foundation, either version 3 of the
 "RTN","C0CEWD1",7,0)
- ;it under the terms of the GNU General Public License as published by
+ ; License, or (at your option) any later version.
 "RTN","C0CEWD1",8,0)
- ;the Free Software Foundation; either version 2 of the License, or
+ ;
 "RTN","C0CEWD1",9,0)
- ;(at your option) any later version.
+ ; This program is distributed in the hope that it will be useful,
 "RTN","C0CEWD1",10,0)
- ;
+ ; but WITHOUT ANY WARRANTY; without even the implied warranty of
 "RTN","C0CEWD1",11,0)
- ;This program is distributed in the hope that it will be useful,
+ ; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 "RTN","C0CEWD1",12,0)
- ;but WITHOUT ANY WARRANTY; without even the implied warranty of
+ ; GNU Affero General Public License for more details.
 "RTN","C0CEWD1",13,0)
- ;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ ;
 "RTN","C0CEWD1",14,0)
- ;GNU General Public License for more details.
+ ; You should have received a copy of the GNU Affero General Public License
 "RTN","C0CEWD1",15,0)
- ;
+ ; along with this program.  If not, see <http://www.gnu.org/licenses/>.
 "RTN","C0CEWD1",16,0)
- ;You should have received a copy of the GNU General Public License along
+ ;
 "RTN","C0CEWD1",17,0)
- ;with this program; if not, write to the Free Software Foundation, Inc.,
+ Q
 "RTN","C0CEWD1",18,0)
- ;51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+ ;
 "RTN","C0CEWD1",19,0)
- ;
+TEST(filepath) ; filepath IS THE PATH/FILE TO BE READ IN
 "RTN","C0CEWD1",20,0)
- Q
+ i $g(^%ZISH)["" d  ; if the VistA Kernal routine %ZISH exists
 "RTN","C0CEWD1",21,0)
- ;
+ . n zfile,zpath,ztmp s (zfile,zpath,ztmp)=""
 "RTN","C0CEWD1",22,0)
-TEST(filepath) ; filepath IS THE PATH/FILE TO BE READ IN
+ . s zfile=$re($p($re(filepath),"/",1)) ;file name
 "RTN","C0CEWD1",23,0)
- i $g(^%ZISH)["" d  ; if the VistA Kernal routine %ZISH exists
+ . s zpath=$p(filepath,zfile,1) ; file path
 "RTN","C0CEWD1",24,0)
- . n zfile,zpath,ztmp s (zfile,zpath,ztmp)=""
+ . s ztmp=$na(^CacheTempEWD($j,0))
 "RTN","C0CEWD1",25,0)
+ . s ok=$$FTG^%ZISH(zpath,zfile,ztmp,2) ; import the file incrementing subscr 2
+"RTN","C0CEWD1",26,0)
+ q
+"RTN","C0CEWD1",27,0)
+ ;
+"RTN","C0CEWD1",28,0)
+TEST2 ;
+"RTN","C0CEWD1",29,0)
+ s zfilepath="/home/vademo2/CCR/PAT_780_CCR_V1_0_17.xml"
+"RTN","C0CEWD1",30,0)
+ ;s ok=$$gtmImportFile^%zewdHTMLParser(zfilepath)
+"RTN","C0CEWD1",31,0)
+ s ok=$$LOAD(zfilepath) ;load the XML file to the EWD global
+"RTN","C0CEWD1",32,0)
+ s ok=$$parseDocument^%zewdHTMLParser("DerekDOM",0)
+"RTN","C0CEWD1",33,0)
+ ;s ok=$$parseXMLFile^%zewdAPI(zfilepath,"fourthDOM")
+"RTN","C0CEWD1",34,0)
+ w ok,!
+"RTN","C0CEWD1",35,0)
+ q
+"RTN","C0CEWD1",36,0)
+ ;
+"RTN","C0CEWD1",37,0)
+LOAD(filepath) ; load an xml file into the EWD global for DOM processing
+"RTN","C0CEWD1",38,0)
+ ; need to call s error=$$parseDocument^%zewdHTMLParser(docName,isHTML)
+"RTN","C0CEWD1",39,0)
+ ; after to process it to the DOM - isHTML=0 for XML files
+"RTN","C0CEWD1",40,0)
+ n i
+"RTN","C0CEWD1",41,0)
+ i $g(^%ZISH)["" d  QUIT i ; if VistA Kernal routine %ZISH exists - gpl 2/23/09
+"RTN","C0CEWD1",42,0)
+ . n zfile,zpath,ztmp,zok s (zfile,zpath,ztmp)=""
+"RTN","C0CEWD1",43,0)
  . s zfile=$re($p($re(filepath),"/",1)) ;file name
-"RTN","C0CEWD1",26,0)
+"RTN","C0CEWD1",44,0)
  . s zpath=$p(filepath,zfile,1) ; file path
-"RTN","C0CEWD1",27,0)
+"RTN","C0CEWD1",45,0)
  . s ztmp=$na(^CacheTempEWD($j,0))
-"RTN","C0CEWD1",28,0)
- . s ok=$$FTG^%ZISH(zpath,zfile,ztmp,2) ; import the file incrementing subscr 2
-"RTN","C0CEWD1",29,0)
+"RTN","C0CEWD1",46,0)
+ . s zok=$$FTG^%ZISH(zpath,zfile,ztmp,2) ; import the file increment subscr 2
+"RTN","C0CEWD1",47,0)
+ . s i=$o(^CacheTempEWD($j,""),-1) ; highest line number
+"RTN","C0CEWD1",48,0)
+ q i
+"RTN","C0CEWD1",49,0)
+ ;
+"RTN","C0CEWD1",50,0)
+Q(ZQ,ZD) ; SEND QUERY ZQ TO DOM ZD AND DIPLAY NODES RETURNED
+"RTN","C0CEWD1",51,0)
+ I '$D(ZD) S ZD="DerekDOM"
+"RTN","C0CEWD1",52,0)
+ s error=$$select^%zewdXPath(ZQ,ZD,.nodes) ;
+"RTN","C0CEWD1",53,0)
+ d displayNodes^%zewdXPath(.nodes)
+"RTN","C0CEWD1",54,0)
  q
-"RTN","C0CEWD1",30,0)
- ;
-"RTN","C0CEWD1",31,0)
-TEST2 ;
-"RTN","C0CEWD1",32,0)
- s zfilepath="/home/vademo2/CCR/PAT_780_CCR_V1_0_17.xml"
-"RTN","C0CEWD1",33,0)
- ;s ok=$$gtmImportFile^%zewdHTMLParser(zfilepath)
-"RTN","C0CEWD1",34,0)
- s ok=$$LOAD(zfilepath) ;load the XML file to the EWD global
-"RTN","C0CEWD1",35,0)
- s ok=$$parseDocument^%zewdHTMLParser("DerekDOM",0)
-"RTN","C0CEWD1",36,0)
- ;s ok=$$parseXMLFile^%zewdAPI(zfilepath,"fourthDOM")
-"RTN","C0CEWD1",37,0)
- w ok,!
-"RTN","C0CEWD1",38,0)
- q
-"RTN","C0CEWD1",39,0)
- ;
-"RTN","C0CEWD1",40,0)
-LOAD(filepath) ; load an xml file into the EWD global for DOM processing
-"RTN","C0CEWD1",41,0)
- ; need to call s error=$$parseDocument^%zewdHTMLParser(docName,isHTML)
-"RTN","C0CEWD1",42,0)
- ; after to process it to the DOM - isHTML=0 for XML files
-"RTN","C0CEWD1",43,0)
- n i
-"RTN","C0CEWD1",44,0)
- i $g(^%ZISH)["" d  QUIT i ; if VistA Kernal routine %ZISH exists - gpl 2/23/09
-"RTN","C0CEWD1",45,0)
- . n zfile,zpath,ztmp,zok s (zfile,zpath,ztmp)=""
-"RTN","C0CEWD1",46,0)
- . s zfile=$re($p($re(filepath),"/",1)) ;file name
-"RTN","C0CEWD1",47,0)
- . s zpath=$p(filepath,zfile,1) ; file path
-"RTN","C0CEWD1",48,0)
- . s ztmp=$na(^CacheTempEWD($j,0))
-"RTN","C0CEWD1",49,0)
- . s zok=$$FTG^%ZISH(zpath,zfile,ztmp,2) ; import the file increment subscr 2
-"RTN","C0CEWD1",50,0)
- . s i=$o(^CacheTempEWD($j,""),-1) ; highest line number
-"RTN","C0CEWD1",51,0)
- q i
-"RTN","C0CEWD1",52,0)
- ;
-"RTN","C0CEWD1",53,0)
-Q(ZQ,ZD) ; SEND QUERY ZQ TO DOM ZD AND DIPLAY NODES RETURNED
-"RTN","C0CEWD1",54,0)
- I '$D(ZD) S ZD="DerekDOM"
 "RTN","C0CEWD1",55,0)
- s error=$$select^%zewdXPath(ZQ,ZD,.nodes) ;
+ ;
 "RTN","C0CEWD1",56,0)
- d displayNodes^%zewdXPath(.nodes)
+GET1URL0(URL) ;
 "RTN","C0CEWD1",57,0)
- q
+ s ok=$$httpGET^%zewdGTM(URL,.gpl)
 "RTN","C0CEWD1",58,0)
- ;
+ D INDEX^C0CXPATH("gpl","gpl2")
 "RTN","C0CEWD1",59,0)
-GET1URL0(URL) ;
+ W !,"S URL=""",URL,"""",!
 "RTN","C0CEWD1",60,0)
- s ok=$$httpGET^%zewdGTM(URL,.gpl)
+ S G=""
 "RTN","C0CEWD1",61,0)
- D INDEX^C0CXPATH("gpl","gpl2")
+ F  S G=$O(gpl2(G)) Q:G=""  D  ;
 "RTN","C0CEWD1",62,0)
- W !,"S URL=""",URL,"""",!
+ . W " S VDX(""",G,""")=""",gpl2(G),"""",!
 "RTN","C0CEWD1",63,0)
- S G=""
+ W !
 "RTN","C0CEWD1",64,0)
- F  S G=$O(gpl2(G)) Q:G=""  D  ;
-"RTN","C0CEWD1",65,0)
- . W " S VDX(""",G,""")=""",gpl2(G),"""",!
-"RTN","C0CEWD1",66,0)
- W !
-"RTN","C0CEWD1",67,0)
  Q
 "RTN","C0CFM1")
-0^24^B27048099
+0^24^B26826658
 "RTN","C0CFM1",1,0)
 C0CFM1   ; CCDCCR/GPL - CCR FILEMAN utilities; 12/6/08
 "RTN","C0CFM1",2,0)
- ;;1.2;C0C;;May 11, 2012;Build 50
+ ;;1.2;CCD/CCR GENERATION UTILITIES;;Oct 30, 2012;Build 51
 "RTN","C0CFM1",3,0)
- ;Copyright 2009 George Lilly.  Licensed under the terms of the GNU
+ ;Copyright 2009 George Lilly.  
 "RTN","C0CFM1",4,0)
- ;General Public License See attached copy of the License.
+ ;
 "RTN","C0CFM1",5,0)
- ;
+ ; This program is free software: you can redistribute it and/or modify
 "RTN","C0CFM1",6,0)
- ;This program is free software; you can redistribute it and/or modify
+ ; it under the terms of the GNU Affero General Public License as
 "RTN","C0CFM1",7,0)
- ;it under the terms of the GNU General Public License as published by
+ ; published by the Free Software Foundation, either version 3 of the
 "RTN","C0CFM1",8,0)
- ;the Free Software Foundation; either version 2 of the License, or
+ ; License, or (at your option) any later version.
 "RTN","C0CFM1",9,0)
- ;(at your option) any later version.
+ ;
 "RTN","C0CFM1",10,0)
- ;
+ ; This program is distributed in the hope that it will be useful,
 "RTN","C0CFM1",11,0)
- ;This program is distributed in the hope that it will be useful,
+ ; but WITHOUT ANY WARRANTY; without even the implied warranty of
 "RTN","C0CFM1",12,0)
- ;but WITHOUT ANY WARRANTY; without even the implied warranty of
+ ; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 "RTN","C0CFM1",13,0)
- ;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ ; GNU Affero General Public License for more details.
 "RTN","C0CFM1",14,0)
- ;GNU General Public License for more details.
+ ;
 "RTN","C0CFM1",15,0)
- ;
+ ; You should have received a copy of the GNU Affero General Public License
 "RTN","C0CFM1",16,0)
- ;You should have received a copy of the GNU General Public License along
+ ; along with this program.  If not, see <http://www.gnu.org/licenses/>.
 "RTN","C0CFM1",17,0)
- ;with this program; if not, write to the Free Software Foundation, Inc.,
+ ;
 "RTN","C0CFM1",18,0)
- ;51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+ ;
 "RTN","C0CFM1",19,0)
- ;
+ W "This is the CCR FILEMAN Utility Library ",!
 "RTN","C0CFM1",20,0)
- W "This is the CCR FILEMAN Utility Library ",!
+ W !
 "RTN","C0CFM1",21,0)
- W !
+ Q
 "RTN","C0CFM1",22,0)
+ ;
+"RTN","C0CFM1",23,0)
+PUTRIM(DFN,ZWHICH) ;DFN IS PATIENT , WHICH IS ELEMENT TYPE
+"RTN","C0CFM1",24,0)
+ ;
+"RTN","C0CFM1",25,0)
+ S C0CGLB=$NA(^TMP("GPLRIM","VARS",DFN))
+"RTN","C0CFM1",26,0)
+ I '$D(ZWHICH) S ZWHICH="ALL"
+"RTN","C0CFM1",27,0)
+ I ZWHICH'="ALL" D  ; SINGLE SECTION REQUESTED
+"RTN","C0CFM1",28,0)
+ . S C0CVARS=$NA(@C0CGLB@(ZWHICH))
+"RTN","C0CFM1",29,0)
+ . D PUTRIM1(DFN,ZWHICH,C0CVARS) ; IF ONE SECTION
+"RTN","C0CFM1",30,0)
+ E  D  ; MULTIPLE SECTIONS
+"RTN","C0CFM1",31,0)
+ . S C0CVARS=$NA(@C0CGLB)
+"RTN","C0CFM1",32,0)
+ . S C0CI=""
+"RTN","C0CFM1",33,0)
+ . F  S C0CI=$O(@C0CVARS@(C0CI)) Q:C0CI=""  D  ;FOR EACH SECTION
+"RTN","C0CFM1",34,0)
+ . . S C0CVARSN=$NA(@C0CVARS@(C0CI)) ; GRAB ONE SECTION
+"RTN","C0CFM1",35,0)
+ . . D PUTRIM1(DFN,C0CI,C0CVARSN)
+"RTN","C0CFM1",36,0)
  Q
-"RTN","C0CFM1",23,0)
- ;
-"RTN","C0CFM1",24,0)
-PUTRIM(DFN,ZWHICH) ;DFN IS PATIENT , WHICH IS ELEMENT TYPE
-"RTN","C0CFM1",25,0)
- ;
-"RTN","C0CFM1",26,0)
- S C0CGLB=$NA(^TMP("GPLRIM","VARS",DFN))
-"RTN","C0CFM1",27,0)
- I '$D(ZWHICH) S ZWHICH="ALL"
-"RTN","C0CFM1",28,0)
- I ZWHICH'="ALL" D  ; SINGLE SECTION REQUESTED
-"RTN","C0CFM1",29,0)
- . S C0CVARS=$NA(@C0CGLB@(ZWHICH))
-"RTN","C0CFM1",30,0)
- . D PUTRIM1(DFN,ZWHICH,C0CVARS) ; IF ONE SECTION
-"RTN","C0CFM1",31,0)
- E  D  ; MULTIPLE SECTIONS
-"RTN","C0CFM1",32,0)
- . S C0CVARS=$NA(@C0CGLB)
-"RTN","C0CFM1",33,0)
- . S C0CI=""
-"RTN","C0CFM1",34,0)
- . F  S C0CI=$O(@C0CVARS@(C0CI)) Q:C0CI=""  D  ;FOR EACH SECTION
-"RTN","C0CFM1",35,0)
- . . S C0CVARSN=$NA(@C0CVARS@(C0CI)) ; GRAB ONE SECTION
-"RTN","C0CFM1",36,0)
- . . D PUTRIM1(DFN,C0CI,C0CVARSN)
 "RTN","C0CFM1",37,0)
+ ;
+"RTN","C0CFM1",38,0)
+PUTRIM1(DFN,ZZTYP,ZVARS) ; PUT ONE SECTION OF VARIABLES INTO CCR ELEMENTS
+"RTN","C0CFM1",39,0)
+ ; ZVARS IS PASSED BY NAME AN HAS THE FORM @ZVARS@(1,"VAR1")="VAL1"
+"RTN","C0CFM1",40,0)
+ S C0CX=0
+"RTN","C0CFM1",41,0)
+ F  S C0CX=$O(@ZVARS@(C0CX)) Q:C0CX=""  D  ; FOR EACH OCCURANCE
+"RTN","C0CFM1",42,0)
+ . W "ZOCC=",C0CX,!
+"RTN","C0CFM1",43,0)
+ . S C0CV=$NA(@ZVARS@(C0CX)) ; VARIABLES FOR THIS OCCURANCE
+"RTN","C0CFM1",44,0)
+ . D PUTELS(DFN,ZZTYP,C0CX,C0CV) ; PUT THEM TO THE CCR ELEMENTS FILE
+"RTN","C0CFM1",45,0)
  Q
-"RTN","C0CFM1",38,0)
- ;
-"RTN","C0CFM1",39,0)
-PUTRIM1(DFN,ZZTYP,ZVARS) ; PUT ONE SECTION OF VARIABLES INTO CCR ELEMENTS
-"RTN","C0CFM1",40,0)
- ; ZVARS IS PASSED BY NAME AN HAS THE FORM @ZVARS@(1,"VAR1")="VAL1"
-"RTN","C0CFM1",41,0)
- S C0CX=0
-"RTN","C0CFM1",42,0)
- F  S C0CX=$O(@ZVARS@(C0CX)) Q:C0CX=""  D  ; FOR EACH OCCURANCE
-"RTN","C0CFM1",43,0)
- . W "ZOCC=",C0CX,!
-"RTN","C0CFM1",44,0)
- . S C0CV=$NA(@ZVARS@(C0CX)) ; VARIABLES FOR THIS OCCURANCE
-"RTN","C0CFM1",45,0)
- . D PUTELS(DFN,ZZTYP,C0CX,C0CV) ; PUT THEM TO THE CCR ELEMENTS FILE
 "RTN","C0CFM1",46,0)
+ ;
+"RTN","C0CFM1",47,0)
+PUTELS(DFN,ZTYPE,ZOCC,ZVALS) ; PUT CCR VALUES INTO THE CCR ELEMENTS FILE
+"RTN","C0CFM1",48,0)
+ ; ^C0C(171.201,   DFN IS THE PATIENT IEN PASSED BY VALUE
+"RTN","C0CFM1",49,0)
+ ; ZTYPE IS THE NODE TYPE IE RESULTS,PROBLEMS PASSED BY VALUE
+"RTN","C0CFM1",50,0)
+ ; ZOCC IS THE OCCURANCE NUMBER IE PROBLEM NUMBER 1,2,3 ETC
+"RTN","C0CFM1",51,0)
+ ; ZVALS ARE THE VARIABLES AND VALUES PASSED BY NAME AND IN THE FORM
+"RTN","C0CFM1",52,0)
+ ; @ZVALS@("VAR1")="VALUE1" FOR ALL VARIABLES IN THIS ELEMENT
+"RTN","C0CFM1",53,0)
+ ; AND @ZVALS@("M",SUBOCCUR,"VAR2")="VALUE2" FOR SUB VARIABLES
+"RTN","C0CFM1",54,0)
+ ;
+"RTN","C0CFM1",55,0)
+ S ZSRC=1 ; CCR SOURCE IS ASSUMED TO BE THIS EHR, WHICH IS ALWAYS SOURCE 1
+"RTN","C0CFM1",56,0)
+ ; PUT THIS IN PARAMETERS - SO SOURCE NUMBER FOR PROCESSING IN CONFIGURABLE
+"RTN","C0CFM1",57,0)
+ N ZF,ZFV S ZF=171.201 S ZFV=171.2012
+"RTN","C0CFM1",58,0)
+ S ZSUBF=171.20122 ;FILE AND SUBFILE NUMBERS
+"RTN","C0CFM1",59,0)
+ N ZSFV S ZSFV=171.201221 ; SUBFILE VARIABLE FILE NUMBER
+"RTN","C0CFM1",60,0)
+ N ZTYPN S ZTYPN=$O(^C0CDIC(170.101,"B",ZTYPE,""))
+"RTN","C0CFM1",61,0)
+ W "ZTYPE: ",ZTYPE," ",ZTYPN,!
+"RTN","C0CFM1",62,0)
+ N ZVARN ; IEN OF VARIABLE BEING PROCESSED
+"RTN","C0CFM1",63,0)
+ ;N C0CFDA ; FDA FOR CCR ELEMENT UPDATE
+"RTN","C0CFM1",64,0)
+ S C0CFDA(ZF,"?+1,",.01)=DFN
+"RTN","C0CFM1",65,0)
+ S C0CFDA(ZF,"?+1,",.02)=ZSRC
+"RTN","C0CFM1",66,0)
+ S C0CFDA(ZF,"?+1,",.03)=ZTYPN
+"RTN","C0CFM1",67,0)
+ S C0CFDA(ZF,"?+1,",.04)=ZOCC ;CREATE OCCURANCE
+"RTN","C0CFM1",68,0)
+ K ZERR
+"RTN","C0CFM1",69,0)
+ D UPDATE^DIE("","C0CFDA","","ZERR") ;ASSIGN RECORD NUMBER
+"RTN","C0CFM1",70,0)
+ I $D(ZERR) S $EC=",U1,"
+"RTN","C0CFM1",71,0)
+ K C0CFDA
+"RTN","C0CFM1",72,0)
+ S ZD0=$O(^C0C(ZF,"C",DFN,ZSRC,ZTYPN,ZOCC,""))
+"RTN","C0CFM1",73,0)
+ W "RECORD NUMBER: ",ZD0,!
+"RTN","C0CFM1",74,0)
+ ;B
+"RTN","C0CFM1",75,0)
+ S ZCNT=0
+"RTN","C0CFM1",76,0)
+ S ZC0CI="" ;
+"RTN","C0CFM1",77,0)
+ F  S ZC0CI=$O(@ZVALS@(ZC0CI)) Q:ZC0CI=""  D  ;
+"RTN","C0CFM1",78,0)
+ . I ZC0CI'="M" D  ; NOT A SUBVARIABLE
+"RTN","C0CFM1",79,0)
+ . . S ZCNT=ZCNT+1 ;INCREMENT COUNT
+"RTN","C0CFM1",80,0)
+ . . S ZVARN=$$VARPTR(ZC0CI,ZTYPE) ;GET THE POINTER TO THE VAR IN THE CCR DICT
+"RTN","C0CFM1",81,0)
+ . . ; WILL ALLOW FOR LAYGO IF THE VARIABLE IS NOT FOUND
+"RTN","C0CFM1",82,0)
+ . . S C0CFDA(ZFV,"?+"_ZCNT_","_ZD0_",",.01)=ZVARN
+"RTN","C0CFM1",83,0)
+ . . S C0CFDA(ZFV,"?+"_ZCNT_","_ZD0_",",1)=@ZVALS@(ZC0CI)
+"RTN","C0CFM1",84,0)
+ . . ;S C0CFDA(ZSFV,"+1,"_DFN_","_ZSRC_","_ZTYPN_","_ZOCC_",",.01)=ZVARN
+"RTN","C0CFM1",85,0)
+ . . ;S C0CFDA(ZSFV,"+1,"_DFN_","_ZSRC_","_ZTYPN_","_ZOCC_",",1)=@ZVALS@(ZC0CI)
+"RTN","C0CFM1",86,0)
+ ;S GT1(170,"?+1,",.01)="ZZZ NEW MEDVEHICLETEXT"
+"RTN","C0CFM1",87,0)
+ ;S GT1(170,"?+1,",12)="DIR"
+"RTN","C0CFM1",88,0)
+ ;S GT1(171.201221,"?+1,1,5,1,",.01)="ZZZ NEW MEDVEHICLETEXT"
+"RTN","C0CFM1",89,0)
+ ;S GT1(171.201221,"+1,1,5,1,",1)="THIRD NEW MED DIRECTION TEXT"
+"RTN","C0CFM1",90,0)
+ D CLEAN^DILF
+"RTN","C0CFM1",91,0)
+ D UPDATE^DIE("","C0CFDA","","ZERR")
+"RTN","C0CFM1",92,0)
  Q
-"RTN","C0CFM1",47,0)
- ;
-"RTN","C0CFM1",48,0)
-PUTELS(DFN,ZTYPE,ZOCC,ZVALS) ; PUT CCR VALUES INTO THE CCR ELEMENTS FILE
-"RTN","C0CFM1",49,0)
- ; ^C0C(171.201,   DFN IS THE PATIENT IEN PASSED BY VALUE
-"RTN","C0CFM1",50,0)
- ; ZTYPE IS THE NODE TYPE IE RESULTS,PROBLEMS PASSED BY VALUE
-"RTN","C0CFM1",51,0)
- ; ZOCC IS THE OCCURANCE NUMBER IE PROBLEM NUMBER 1,2,3 ETC
-"RTN","C0CFM1",52,0)
- ; ZVALS ARE THE VARIABLES AND VALUES PASSED BY NAME AND IN THE FORM
-"RTN","C0CFM1",53,0)
- ; @ZVALS@("VAR1")="VALUE1" FOR ALL VARIABLES IN THIS ELEMENT
-"RTN","C0CFM1",54,0)
- ; AND @ZVALS@("M",SUBOCCUR,"VAR2")="VALUE2" FOR SUB VARIABLES
-"RTN","C0CFM1",55,0)
- ;
-"RTN","C0CFM1",56,0)
- S ZSRC=1 ; CCR SOURCE IS ASSUMED TO BE THIS EHR, WHICH IS ALWAYS SOURCE 1
-"RTN","C0CFM1",57,0)
- ; PUT THIS IN PARAMETERS - SO SOURCE NUMBER FOR PROCESSING IN CONFIGURABLE
-"RTN","C0CFM1",58,0)
- N ZF,ZFV S ZF=171.201 S ZFV=171.2012
-"RTN","C0CFM1",59,0)
- S ZSUBF=171.20122 ;FILE AND SUBFILE NUMBERS
-"RTN","C0CFM1",60,0)
- N ZSFV S ZSFV=171.201221 ; SUBFILE VARIABLE FILE NUMBER
-"RTN","C0CFM1",61,0)
- N ZTYPN S ZTYPN=$O(^C0CDIC(170.101,"B",ZTYPE,""))
-"RTN","C0CFM1",62,0)
- W "ZTYPE: ",ZTYPE," ",ZTYPN,!
-"RTN","C0CFM1",63,0)
- N ZVARN ; IEN OF VARIABLE BEING PROCESSED
-"RTN","C0CFM1",64,0)
- ;N C0CFDA ; FDA FOR CCR ELEMENT UPDATE
-"RTN","C0CFM1",65,0)
- S C0CFDA(ZF,"?+1,",.01)=DFN
-"RTN","C0CFM1",66,0)
- S C0CFDA(ZF,"?+1,",.02)=ZSRC
-"RTN","C0CFM1",67,0)
- S C0CFDA(ZF,"?+1,",.03)=ZTYPN
-"RTN","C0CFM1",68,0)
- S C0CFDA(ZF,"?+1,",.04)=ZOCC ;CREATE OCCURANCE
-"RTN","C0CFM1",69,0)
- K ZERR
-"RTN","C0CFM1",70,0)
- D UPDATE^DIE("","C0CFDA","","ZERR") ;ASSIGN RECORD NUMBER
-"RTN","C0CFM1",71,0)
- I $D(ZERR) B  ;OOPS
-"RTN","C0CFM1",72,0)
- K C0CFDA
-"RTN","C0CFM1",73,0)
- S ZD0=$O(^C0C(ZF,"C",DFN,ZSRC,ZTYPN,ZOCC,""))
-"RTN","C0CFM1",74,0)
- W "RECORD NUMBER: ",ZD0,!
-"RTN","C0CFM1",75,0)
- ;B
-"RTN","C0CFM1",76,0)
- S ZCNT=0
-"RTN","C0CFM1",77,0)
- S ZC0CI="" ;
-"RTN","C0CFM1",78,0)
- F  S ZC0CI=$O(@ZVALS@(ZC0CI)) Q:ZC0CI=""  D  ;
-"RTN","C0CFM1",79,0)
- . I ZC0CI'="M" D  ; NOT A SUBVARIABLE
-"RTN","C0CFM1",80,0)
- . . S ZCNT=ZCNT+1 ;INCREMENT COUNT
-"RTN","C0CFM1",81,0)
- . . S ZVARN=$$VARPTR(ZC0CI,ZTYPE) ;GET THE POINTER TO THE VAR IN THE CCR DICT
-"RTN","C0CFM1",82,0)
- . . ; WILL ALLOW FOR LAYGO IF THE VARIABLE IS NOT FOUND
-"RTN","C0CFM1",83,0)
- . . S C0CFDA(ZFV,"?+"_ZCNT_","_ZD0_",",.01)=ZVARN
-"RTN","C0CFM1",84,0)
- . . S C0CFDA(ZFV,"?+"_ZCNT_","_ZD0_",",1)=@ZVALS@(ZC0CI)
-"RTN","C0CFM1",85,0)
- . . ;S C0CFDA(ZSFV,"+1,"_DFN_","_ZSRC_","_ZTYPN_","_ZOCC_",",.01)=ZVARN
-"RTN","C0CFM1",86,0)
- . . ;S C0CFDA(ZSFV,"+1,"_DFN_","_ZSRC_","_ZTYPN_","_ZOCC_",",1)=@ZVALS@(ZC0CI)
-"RTN","C0CFM1",87,0)
- ;S GT1(170,"?+1,",.01)="ZZZ NEW MEDVEHICLETEXT"
-"RTN","C0CFM1",88,0)
- ;S GT1(170,"?+1,",12)="DIR"
-"RTN","C0CFM1",89,0)
- ;S GT1(171.201221,"?+1,1,5,1,",.01)="ZZZ NEW MEDVEHICLETEXT"
-"RTN","C0CFM1",90,0)
- ;S GT1(171.201221,"+1,1,5,1,",1)="THIRD NEW MED DIRECTION TEXT"
-"RTN","C0CFM1",91,0)
- D CLEAN^DILF
-"RTN","C0CFM1",92,0)
- D UPDATE^DIE("","C0CFDA","","ZERR")
 "RTN","C0CFM1",93,0)
+ ;
+"RTN","C0CFM1",94,0)
+VARPTR(ZVAR,ZTYP) ;EXTRINSIC WHICH RETURNS THE POINTER TO ZVAR IN THE
+"RTN","C0CFM1",95,0)
+ ; CCR DICTIONARY. IT IS LAYGO, AS IT WILL ADD THE VARIABLE TO
+"RTN","C0CFM1",96,0)
+ ; THE CCR DICTIONARY IF IT IS NOT THERE. ZTYP IS REQUIRED FOR LAYGO
+"RTN","C0CFM1",97,0)
+ ;
+"RTN","C0CFM1",98,0)
+ N ZCCRD,ZVARN,C0CFDA2
+"RTN","C0CFM1",99,0)
+ S ZCCRD=170 ; FILE NUMBER FOR CCR DICTIONARY
+"RTN","C0CFM1",100,0)
+ S ZVARN=$O(^C0CDIC(170,"B",ZVAR,"")) ;FIND IEN OF VARIABLE
+"RTN","C0CFM1",101,0)
+ I ZVARN="" D  ; VARIABLE NOT IN CCR DICTIONARY - ADD IT
+"RTN","C0CFM1",102,0)
+ . I '$D(ZTYP) D  Q  ; WON'T ADD A VARIABLE WITHOUT A TYPE
+"RTN","C0CFM1",103,0)
+ . . W "CANNOT ADD VARIABLE WITHOUT A TYPE: ",ZVAR,!
+"RTN","C0CFM1",104,0)
+ . S C0CFDA2(ZCCRD,"?+1,",.01)=ZVAR ; NAME OF NEW VARIABLE
+"RTN","C0CFM1",105,0)
+ . S C0CFDA2(ZCCRD,"?+1,",12)=ZTYP ; TYPE EXTERNAL OF NEW VARIABLE
+"RTN","C0CFM1",106,0)
+ . D CLEAN^DILF ;MAKE SURE ERRORS ARE CLEAN
+"RTN","C0CFM1",107,0)
+ . D UPDATE^DIE("E","C0CFDA2","","ZERR") ;ADD VAR TO CCR DICTIONARY
+"RTN","C0CFM1",108,0)
+ . I $D(ZERR) D  ; LAYGO ERROR
+"RTN","C0CFM1",109,0)
+ . . W "ERROR ADDING "_ZC0CI_" TO CCR DICTIONARY",!
+"RTN","C0CFM1",110,0)
+ . E  D  ;
+"RTN","C0CFM1",111,0)
+ . . D CLEAN^DILF ; CLEAN UP
+"RTN","C0CFM1",112,0)
+ . . S ZVARN=$O(^C0CDIC(170,"B",ZVAR,"")) ;FIND IEN OF VARIABLE
+"RTN","C0CFM1",113,0)
+ . . W "ADDED ",ZVAR," TO CCR DICTIONARY, IEN:",ZVARN,!
+"RTN","C0CFM1",114,0)
+ Q ZVARN
+"RTN","C0CFM1",115,0)
+ ;
+"RTN","C0CFM1",116,0)
+BLDTYPS ; ROUTINE TO POPULATE THE CCR NODE TYPES FILE (^C0CDIC(170.101,)
+"RTN","C0CFM1",117,0)
+ ; THE CCR DICTIONARY (^C0CDIC(170, ) HAS MOST OF WHAT'S NEEDED
+"RTN","C0CFM1",118,0)
+ ;
+"RTN","C0CFM1",119,0)
+ N C0CDIC,C0CNODE ;
+"RTN","C0CFM1",120,0)
+ S C0CDIC=$$FILEREF^C0CRNF(170) ; CLOSED FILE REFERENCE TO THE CCR DICTIONARY
+"RTN","C0CFM1",121,0)
+ S C0CNODE=$$FILEREF^C0CRNF(170.101) ; CLOSED REF TO CCR NODE TYPE FILE
+"RTN","C0CFM1",122,0)
  Q
-"RTN","C0CFM1",94,0)
- ;
-"RTN","C0CFM1",95,0)
-VARPTR(ZVAR,ZTYP) ;EXTRINSIC WHICH RETURNS THE POINTER TO ZVAR IN THE
-"RTN","C0CFM1",96,0)
- ; CCR DICTIONARY. IT IS LAYGO, AS IT WILL ADD THE VARIABLE TO
-"RTN","C0CFM1",97,0)
- ; THE CCR DICTIONARY IF IT IS NOT THERE. ZTYP IS REQUIRED FOR LAYGO
-"RTN","C0CFM1",98,0)
- ;
-"RTN","C0CFM1",99,0)
- N ZCCRD,ZVARN,C0CFDA2
-"RTN","C0CFM1",100,0)
- S ZCCRD=170 ; FILE NUMBER FOR CCR DICTIONARY
-"RTN","C0CFM1",101,0)
- S ZVARN=$O(^C0CDIC(170,"B",ZVAR,"")) ;FIND IEN OF VARIABLE
-"RTN","C0CFM1",102,0)
- I ZVARN="" D  ; VARIABLE NOT IN CCR DICTIONARY - ADD IT
-"RTN","C0CFM1",103,0)
- . I '$D(ZTYP) D  Q  ; WON'T ADD A VARIABLE WITHOUT A TYPE
-"RTN","C0CFM1",104,0)
- . . W "CANNOT ADD VARIABLE WITHOUT A TYPE: ",ZVAR,!
-"RTN","C0CFM1",105,0)
- . S C0CFDA2(ZCCRD,"?+1,",.01)=ZVAR ; NAME OF NEW VARIABLE
-"RTN","C0CFM1",106,0)
- . S C0CFDA2(ZCCRD,"?+1,",12)=ZTYP ; TYPE EXTERNAL OF NEW VARIABLE
-"RTN","C0CFM1",107,0)
- . D CLEAN^DILF ;MAKE SURE ERRORS ARE CLEAN
-"RTN","C0CFM1",108,0)
- . D UPDATE^DIE("E","C0CFDA2","","ZERR") ;ADD VAR TO CCR DICTIONARY
-"RTN","C0CFM1",109,0)
- . I $D(ZERR) D  ; LAYGO ERROR
-"RTN","C0CFM1",110,0)
- . . W "ERROR ADDING "_ZC0CI_" TO CCR DICTIONARY",!
-"RTN","C0CFM1",111,0)
- . E  D  ;
-"RTN","C0CFM1",112,0)
- . . D CLEAN^DILF ; CLEAN UP
-"RTN","C0CFM1",113,0)
- . . S ZVARN=$O(^C0CDIC(170,"B",ZVAR,"")) ;FIND IEN OF VARIABLE
-"RTN","C0CFM1",114,0)
- . . W "ADDED ",ZVAR," TO CCR DICTIONARY, IEN:",ZVARN,!
-"RTN","C0CFM1",115,0)
- Q ZVARN
-"RTN","C0CFM1",116,0)
- ;
-"RTN","C0CFM1",117,0)
-BLDTYPS ; ROUTINE TO POPULATE THE CCR NODE TYPES FILE (^C0CDIC(170.101,)
-"RTN","C0CFM1",118,0)
- ; THE CCR DICTIONARY (^C0CDIC(170, ) HAS MOST OF WHAT'S NEEDED
-"RTN","C0CFM1",119,0)
- ;
-"RTN","C0CFM1",120,0)
- N C0CDIC,C0CNODE ;
-"RTN","C0CFM1",121,0)
- S C0CDIC=$$FILEREF^C0CRNF(170) ; CLOSED FILE REFERENCE TO THE CCR DICTIONARY
-"RTN","C0CFM1",122,0)
- S C0CNODE=$$FILEREF^C0CRNF(170.101) ; CLOSED REF TO CCR NODE TYPE FILE
 "RTN","C0CFM1",123,0)
+ ;
+"RTN","C0CFM1",124,0)
+FIXSEC ;FIX THE SECTION FIELD OF THE CCR DICTIONARY.. IT HAS BEEN REDEFINED
+"RTN","C0CFM1",125,0)
+ ; AS A POINTER TO CCR NODE TYPE INSTEAD OF BEING A SET
+"RTN","C0CFM1",126,0)
+ ; THE SET VALUES ARE PRESERVED IN ^KBAI("SECTION") TO FACILITATE THIS
+"RTN","C0CFM1",127,0)
+ ; CONVERSION
+"RTN","C0CFM1",128,0)
+ ;N C0CC,C0CI,C0CJ,C0CN,C0CZX
+"RTN","C0CFM1",129,0)
+ D FIELDS^C0CRNF("C0CC",170)
+"RTN","C0CFM1",130,0)
+ S C0CI=""
+"RTN","C0CFM1",131,0)
+ F  S C0CI=$O(^KBAI("SECTION",C0CI)) Q:C0CI=""  D  ; EACH SECTION
+"RTN","C0CFM1",132,0)
+ . S C0CZX=""
+"RTN","C0CFM1",133,0)
+ . F  S C0CZX=$O(^KBAI("SECTION",C0CI,C0CZX)) Q:C0CZX=""  D  ; EACH VARIABLE
+"RTN","C0CFM1",134,0)
+ . . W "SECTION ",C0CI," VAR ",C0CZX
+"RTN","C0CFM1",135,0)
+ . . S C0CV=$O(^C0CDIC(170.101,"B",C0CI,""))
+"RTN","C0CFM1",136,0)
+ . . W " TYPE: ",C0CV,!
+"RTN","C0CFM1",137,0)
+ . . D SETFDA("SECTION",C0CV)
+"RTN","C0CFM1",138,0)
+ . . ;ZWR C0CFDA
+"RTN","C0CFM1",139,0)
  Q
-"RTN","C0CFM1",124,0)
- ;
-"RTN","C0CFM1",125,0)
-FIXSEC ;FIX THE SECTION FIELD OF THE CCR DICTIONARY.. IT HAS BEEN REDEFINED
-"RTN","C0CFM1",126,0)
- ; AS A POINTER TO CCR NODE TYPE INSTEAD OF BEING A SET
-"RTN","C0CFM1",127,0)
- ; THE SET VALUES ARE PRESERVED IN ^KBAI("SECTION") TO FACILITATE THIS
-"RTN","C0CFM1",128,0)
- ; CONVERSION
-"RTN","C0CFM1",129,0)
- ;N C0CC,C0CI,C0CJ,C0CN,C0CZX
-"RTN","C0CFM1",130,0)
- D FIELDS^C0CRNF("C0CC",170)
-"RTN","C0CFM1",131,0)
- S C0CI=""
-"RTN","C0CFM1",132,0)
- F  S C0CI=$O(^KBAI("SECTION",C0CI)) Q:C0CI=""  D  ; EACH SECTION
-"RTN","C0CFM1",133,0)
- . S C0CZX=""
-"RTN","C0CFM1",134,0)
- . F  S C0CZX=$O(^KBAI("SECTION",C0CI,C0CZX)) Q:C0CZX=""  D  ; EACH VARIABLE
-"RTN","C0CFM1",135,0)
- . . W "SECTION ",C0CI," VAR ",C0CZX
-"RTN","C0CFM1",136,0)
- . . S C0CV=$O(^C0CDIC(170.101,"B",C0CI,""))
-"RTN","C0CFM1",137,0)
- . . W " TYPE: ",C0CV,!
-"RTN","C0CFM1",138,0)
- . . D SETFDA("SECTION",C0CV)
-"RTN","C0CFM1",139,0)
- . . ;ZWR C0CFDA
 "RTN","C0CFM1",140,0)
+ ;
+"RTN","C0CFM1",141,0)
+SETFDA(C0CSN,C0CSV) ; INTERNAL ROUTINE TO MAKE AN FDA ENTRY FOR FIELD C0CSN
+"RTN","C0CFM1",142,0)
+ ; TO SET TO VALUE C0CSV.
+"RTN","C0CFM1",143,0)
+ ; C0CFDA,C0CC,C0CZX ARE ASSUMED FROM THE CALLING ROUTINE
+"RTN","C0CFM1",144,0)
+ ; C0CSN,C0CSV ARE PASSED BY VALUE
+"RTN","C0CFM1",145,0)
+ ;
+"RTN","C0CFM1",146,0)
+ N C0CSI,C0CSJ
+"RTN","C0CFM1",147,0)
+ S C0CSI=$$ZFILE(C0CSN,"C0CC") ; FILE NUMBER
+"RTN","C0CFM1",148,0)
+ S C0CSJ=$$ZFIELD(C0CSN,"C0CC") ; FIELD NUMBER
+"RTN","C0CFM1",149,0)
+ S C0CFDA(C0CSI,C0CZX_",",C0CSJ)=C0CSV
+"RTN","C0CFM1",150,0)
  Q
-"RTN","C0CFM1",141,0)
- ;
-"RTN","C0CFM1",142,0)
-SETFDA(C0CSN,C0CSV) ; INTERNAL ROUTINE TO MAKE AN FDA ENTRY FOR FIELD C0CSN
-"RTN","C0CFM1",143,0)
- ; TO SET TO VALUE C0CSV.
-"RTN","C0CFM1",144,0)
- ; C0CFDA,C0CC,C0CZX ARE ASSUMED FROM THE CALLING ROUTINE
-"RTN","C0CFM1",145,0)
- ; C0CSN,C0CSV ARE PASSED BY VALUE
-"RTN","C0CFM1",146,0)
- ;
-"RTN","C0CFM1",147,0)
- N C0CSI,C0CSJ
-"RTN","C0CFM1",148,0)
- S C0CSI=$$ZFILE(C0CSN,"C0CC") ; FILE NUMBER
-"RTN","C0CFM1",149,0)
- S C0CSJ=$$ZFIELD(C0CSN,"C0CC") ; FIELD NUMBER
-"RTN","C0CFM1",150,0)
- S C0CFDA(C0CSI,C0CZX_",",C0CSJ)=C0CSV
 "RTN","C0CFM1",151,0)
- Q
+ZFILE(ZFN,ZTAB) ; EXTRINSIC TO RETURN FILE NUMBER FOR FIELD NAME PASSED
 "RTN","C0CFM1",152,0)
-ZFILE(ZFN,ZTAB) ; EXTRINSIC TO RETURN FILE NUMBER FOR FIELD NAME PASSED
+ ; BY VALUE IN ZFN. FILE NUMBER IS PIECE 1 OF C0CA(ZFN)
 "RTN","C0CFM1",153,0)
- ; BY VALUE IN ZFN. FILE NUMBER IS PIECE 1 OF C0CA(ZFN)
+ ; IF ZTAB IS NULL, IT DEFAULTS TO C0CA
 "RTN","C0CFM1",154,0)
+ I '$D(ZTAB) S ZTAB="C0CA"
+"RTN","C0CFM1",155,0)
+ N ZR
+"RTN","C0CFM1",156,0)
+ I $D(@ZTAB@(ZFN)) S ZR=$P(@ZTAB@(ZFN),"^",1)
+"RTN","C0CFM1",157,0)
+ E  S ZR=""
+"RTN","C0CFM1",158,0)
+ Q ZR
+"RTN","C0CFM1",159,0)
+ZFIELD(ZFN,ZTAB) ;EXTRINSIC TO RETURN FIELD NUMBER FOR FIELD NAME PASSED
+"RTN","C0CFM1",160,0)
+ ; BY VALUE IN ZFN. FILE NUMBER IS PIECE 2 OF C0CA(ZFN)
+"RTN","C0CFM1",161,0)
  ; IF ZTAB IS NULL, IT DEFAULTS TO C0CA
-"RTN","C0CFM1",155,0)
+"RTN","C0CFM1",162,0)
  I '$D(ZTAB) S ZTAB="C0CA"
-"RTN","C0CFM1",156,0)
+"RTN","C0CFM1",163,0)
  N ZR
-"RTN","C0CFM1",157,0)
- I $D(@ZTAB@(ZFN)) S ZR=$P(@ZTAB@(ZFN),"^",1)
-"RTN","C0CFM1",158,0)
+"RTN","C0CFM1",164,0)
+ I $D(@ZTAB@(ZFN)) S ZR=$P(@ZTAB@(ZFN),"^",2)
+"RTN","C0CFM1",165,0)
  E  S ZR=""
-"RTN","C0CFM1",159,0)
+"RTN","C0CFM1",166,0)
  Q ZR
-"RTN","C0CFM1",160,0)
-ZFIELD(ZFN,ZTAB) ;EXTRINSIC TO RETURN FIELD NUMBER FOR FIELD NAME PASSED
-"RTN","C0CFM1",161,0)
- ; BY VALUE IN ZFN. FILE NUMBER IS PIECE 2 OF C0CA(ZFN)
-"RTN","C0CFM1",162,0)
+"RTN","C0CFM1",167,0)
+ ;
+"RTN","C0CFM1",168,0)
+ZVALUE(ZFN,ZTAB) ;EXTRINSIC TO RETURN VALUE FOR FIELD NAME PASSED
+"RTN","C0CFM1",169,0)
+ ; BY VALUE IN ZFN. FILE NUMBER IS PIECE 3 OF C0CA(ZFN)
+"RTN","C0CFM1",170,0)
  ; IF ZTAB IS NULL, IT DEFAULTS TO C0CA
-"RTN","C0CFM1",163,0)
+"RTN","C0CFM1",171,0)
  I '$D(ZTAB) S ZTAB="C0CA"
-"RTN","C0CFM1",164,0)
+"RTN","C0CFM1",172,0)
  N ZR
-"RTN","C0CFM1",165,0)
- I $D(@ZTAB@(ZFN)) S ZR=$P(@ZTAB@(ZFN),"^",2)
-"RTN","C0CFM1",166,0)
+"RTN","C0CFM1",173,0)
+ I $D(@ZTAB@(ZFN)) S ZR=$P(@ZTAB@(ZFN),"^",3)
+"RTN","C0CFM1",174,0)
  E  S ZR=""
-"RTN","C0CFM1",167,0)
+"RTN","C0CFM1",175,0)
  Q ZR
-"RTN","C0CFM1",168,0)
- ;
-"RTN","C0CFM1",169,0)
-ZVALUE(ZFN,ZTAB) ;EXTRINSIC TO RETURN VALUE FOR FIELD NAME PASSED
-"RTN","C0CFM1",170,0)
- ; BY VALUE IN ZFN. FILE NUMBER IS PIECE 3 OF C0CA(ZFN)
-"RTN","C0CFM1",171,0)
- ; IF ZTAB IS NULL, IT DEFAULTS TO C0CA
-"RTN","C0CFM1",172,0)
- I '$D(ZTAB) S ZTAB="C0CA"
-"RTN","C0CFM1",173,0)
- N ZR
-"RTN","C0CFM1",174,0)
- I $D(@ZTAB@(ZFN)) S ZR=$P(@ZTAB@(ZFN),"^",3)
-"RTN","C0CFM1",175,0)
- E  S ZR=""
 "RTN","C0CFM1",176,0)
- Q ZR
-"RTN","C0CFM1",177,0)
  ;
 "RTN","C0CFM2")
-0^31^B102195978
+0^31^B99587435
 "RTN","C0CFM2",1,0)
 C0CFM2   ; CCDCCR/GPL - CCR FILEMAN utilities; 12/6/08
 "RTN","C0CFM2",2,0)
- ;;1.2;C0C;;May 11, 2012;Build 50
+ ;;1.2;CCD/CCR GENERATION UTILITIES;;Oct 30, 2012;Build 51
 "RTN","C0CFM2",3,0)
- ;Copyright 2009 George Lilly.  Licensed under the terms of the GNU
+ ;Copyright 2009 George Lilly.  
 "RTN","C0CFM2",4,0)
- ;General Public License See attached copy of the License.
+ ;
 "RTN","C0CFM2",5,0)
- ;
+ ; This program is free software: you can redistribute it and/or modify
 "RTN","C0CFM2",6,0)
- ;This program is free software; you can redistribute it and/or modify
+ ; it under the terms of the GNU Affero General Public License as
 "RTN","C0CFM2",7,0)
- ;it under the terms of the GNU General Public License as published by
+ ; published by the Free Software Foundation, either version 3 of the
 "RTN","C0CFM2",8,0)
- ;the Free Software Foundation; either version 2 of the License, or
+ ; License, or (at your option) any later version.
 "RTN","C0CFM2",9,0)
- ;(at your option) any later version.
+ ;
 "RTN","C0CFM2",10,0)
- ;
+ ; This program is distributed in the hope that it will be useful,
 "RTN","C0CFM2",11,0)
- ;This program is distributed in the hope that it will be useful,
+ ; but WITHOUT ANY WARRANTY; without even the implied warranty of
 "RTN","C0CFM2",12,0)
- ;but WITHOUT ANY WARRANTY; without even the implied warranty of
+ ; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 "RTN","C0CFM2",13,0)
- ;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ ; GNU Affero General Public License for more details.
 "RTN","C0CFM2",14,0)
- ;GNU General Public License for more details.
+ ;
 "RTN","C0CFM2",15,0)
- ;
+ ; You should have received a copy of the GNU Affero General Public License
 "RTN","C0CFM2",16,0)
- ;You should have received a copy of the GNU General Public License along
+ ; along with this program.  If not, see <http://www.gnu.org/licenses/>.
 "RTN","C0CFM2",17,0)
- ;with this program; if not, write to the Free Software Foundation, Inc.,
+ ;
 "RTN","C0CFM2",18,0)
- ;51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+ ;
 "RTN","C0CFM2",19,0)
- ;
+ W "This is the CCR FILEMAN Utility Library ",!
 "RTN","C0CFM2",20,0)
- W "This is the CCR FILEMAN Utility Library ",!
+ ; THIS SET OF ROUTINES USE CCR E2 (^C0CE(, FILE 171.101) INSTEAD OF
 "RTN","C0CFM2",21,0)
- ; THIS SET OF ROUTINES USE CCR E2 (^C0CE(, FILE 171.101) INSTEAD OF
+ ; CCR ELEMENTS (^C0C(179.201,
 "RTN","C0CFM2",22,0)
- ; CCR ELEMENTS (^C0C(179.201,
+ ; E2 IS A SIMPLIFICATION OF CCR ELEMENTS WHERE SUB-ELEMENTS ARE
 "RTN","C0CFM2",23,0)
- ; E2 IS A SIMPLIFICATION OF CCR ELEMENTS WHERE SUB-ELEMENTS ARE
+ ; AT THE TOP LEVEL. OCCURANCE, THE 4TH PART OF THE KEY IS NOW FREE TEXT
 "RTN","C0CFM2",24,0)
- ; AT THE TOP LEVEL. OCCURANCE, THE 4TH PART OF THE KEY IS NOW FREE TEXT
+ ; AND HAS THE FORM X;Y FOR SUB-ELEMENTS
 "RTN","C0CFM2",25,0)
- ; AND HAS THE FORM X;Y FOR SUB-ELEMENTS
+ ; ALL SUB-VARIABLES HAVE BEEN REMOVED
 "RTN","C0CFM2",26,0)
- ; ALL SUB-VARIABLES HAVE BEEN REMOVED
+ W !
 "RTN","C0CFM2",27,0)
- W !
+ Q
 "RTN","C0CFM2",28,0)
+ ;
+"RTN","C0CFM2",29,0)
+RIMTBL(ZWHICH) ; PUT ALL PATIENT IN RIMTBL ZWHICH INTO THE CCR ELEMENTS FILE
+"RTN","C0CFM2",30,0)
+ ;
+"RTN","C0CFM2",31,0)
+ I '$D(RIMBASE) D ASETUP^C0CRIMA ; FOR COMMAND LINE CALLS
+"RTN","C0CFM2",32,0)
+ N ZI,ZJ,ZC,ZPATBASE
+"RTN","C0CFM2",33,0)
+ S ZPATBASE=$NA(@RIMBASE@("RIMTBL","PATS",ZWHICH))
+"RTN","C0CFM2",34,0)
+ S ZI=""
+"RTN","C0CFM2",35,0)
+ F ZJ=0:0 D  Q:$O(@ZPATBASE@(ZI))=""  ; TIL END
+"RTN","C0CFM2",36,0)
+ . S ZI=$O(@ZPATBASE@(ZI))
+"RTN","C0CFM2",37,0)
+ . D PUTRIM(ZI) ; EXPORT THE PATIENT TO A FILE
+"RTN","C0CFM2",38,0)
  Q
-"RTN","C0CFM2",29,0)
- ;
-"RTN","C0CFM2",30,0)
-RIMTBL(ZWHICH) ; PUT ALL PATIENT IN RIMTBL ZWHICH INTO THE CCR ELEMENTS FILE
-"RTN","C0CFM2",31,0)
- ;
-"RTN","C0CFM2",32,0)
- I '$D(RIMBASE) D ASETUP^C0CRIMA ; FOR COMMAND LINE CALLS
-"RTN","C0CFM2",33,0)
- N ZI,ZJ,ZC,ZPATBASE
-"RTN","C0CFM2",34,0)
- S ZPATBASE=$NA(@RIMBASE@("RIMTBL","PATS",ZWHICH))
-"RTN","C0CFM2",35,0)
- S ZI=""
-"RTN","C0CFM2",36,0)
- F ZJ=0:0 D  Q:$O(@ZPATBASE@(ZI))=""  ; TIL END
-"RTN","C0CFM2",37,0)
- . S ZI=$O(@ZPATBASE@(ZI))
-"RTN","C0CFM2",38,0)
- . D PUTRIM(ZI) ; EXPORT THE PATIENT TO A FILE
 "RTN","C0CFM2",39,0)
+ ;
+"RTN","C0CFM2",40,0)
+PUTRIM(DFN,ZWHICH) ;DFN IS PATIENT , WHICH IS ELEMENT TYPE
+"RTN","C0CFM2",41,0)
+ ;
+"RTN","C0CFM2",42,0)
+ S C0CGLB=$NA(^TMP("C0CRIM","VARS",DFN))
+"RTN","C0CFM2",43,0)
+ I '$D(ZWHICH) S ZWHICH="ALL"
+"RTN","C0CFM2",44,0)
+ I ZWHICH'="ALL" D  ; SINGLE SECTION REQUESTED
+"RTN","C0CFM2",45,0)
+ . S C0CVARS=$NA(@C0CGLB@(ZWHICH))
+"RTN","C0CFM2",46,0)
+ . D PUTRIM1(DFN,ZWHICH,C0CVARS) ; IF ONE SECTION
+"RTN","C0CFM2",47,0)
+ E  D  ; MULTIPLE SECTIONS
+"RTN","C0CFM2",48,0)
+ . S C0CVARS=$NA(@C0CGLB)
+"RTN","C0CFM2",49,0)
+ . S C0CI=""
+"RTN","C0CFM2",50,0)
+ . F  S C0CI=$O(@C0CVARS@(C0CI)) Q:C0CI=""  D  ;FOR EACH SECTION
+"RTN","C0CFM2",51,0)
+ . . S C0CVARSN=$NA(@C0CVARS@(C0CI)) ; GRAB ONE SECTION
+"RTN","C0CFM2",52,0)
+ . . D PUTRIM1(DFN,C0CI,C0CVARSN)
+"RTN","C0CFM2",53,0)
  Q
-"RTN","C0CFM2",40,0)
- ;
-"RTN","C0CFM2",41,0)
-PUTRIM(DFN,ZWHICH) ;DFN IS PATIENT , WHICH IS ELEMENT TYPE
-"RTN","C0CFM2",42,0)
- ;
-"RTN","C0CFM2",43,0)
- S C0CGLB=$NA(^TMP("C0CRIM","VARS",DFN))
-"RTN","C0CFM2",44,0)
- I '$D(ZWHICH) S ZWHICH="ALL"
-"RTN","C0CFM2",45,0)
- I ZWHICH'="ALL" D  ; SINGLE SECTION REQUESTED
-"RTN","C0CFM2",46,0)
- . S C0CVARS=$NA(@C0CGLB@(ZWHICH))
-"RTN","C0CFM2",47,0)
- . D PUTRIM1(DFN,ZWHICH,C0CVARS) ; IF ONE SECTION
-"RTN","C0CFM2",48,0)
- E  D  ; MULTIPLE SECTIONS
-"RTN","C0CFM2",49,0)
- . S C0CVARS=$NA(@C0CGLB)
-"RTN","C0CFM2",50,0)
- . S C0CI=""
-"RTN","C0CFM2",51,0)
- . F  S C0CI=$O(@C0CVARS@(C0CI)) Q:C0CI=""  D  ;FOR EACH SECTION
-"RTN","C0CFM2",52,0)
- . . S C0CVARSN=$NA(@C0CVARS@(C0CI)) ; GRAB ONE SECTION
-"RTN","C0CFM2",53,0)
- . . D PUTRIM1(DFN,C0CI,C0CVARSN)
 "RTN","C0CFM2",54,0)
+ ;
+"RTN","C0CFM2",55,0)
+PUTRIM1(DFN,ZZTYP,ZVARS) ; PUT ONE SECTION OF VARIABLES INTO CCR ELEMENTS
+"RTN","C0CFM2",56,0)
+ ; ZVARS IS PASSED BY NAME AN HAS THE FORM @ZVARS@(1,"VAR1")="VAL1"
+"RTN","C0CFM2",57,0)
+ S C0CX=0
+"RTN","C0CFM2",58,0)
+ F  S C0CX=$O(@ZVARS@(C0CX)) Q:C0CX=""  D  ; FOR EACH OCCURANCE
+"RTN","C0CFM2",59,0)
+ . W "ZOCC=",C0CX,!
+"RTN","C0CFM2",60,0)
+ . K C0CMDO ; MULTIPLE SUBELEMENTS FOR THIS OCCURANCE PASSED BY NAME
+"RTN","C0CFM2",61,0)
+ . S C0CV=$NA(@ZVARS@(C0CX)) ; VARIABLES FOR THIS OCCURANCE
+"RTN","C0CFM2",62,0)
+ . D PUTELS(DFN,ZZTYP,C0CX,C0CV) ; PUT THEM TO THE CCR ELEMENTS FILE
+"RTN","C0CFM2",63,0)
+ . I $D(C0CMDO) D  ; MULTIPLES TO HANDLE (THIS IS INSTEAD OF RECURSION :()
+"RTN","C0CFM2",64,0)
+ . . N ZZCNT,ZZC0CI,ZZVALS,ZT,ZZCNT,ZV
+"RTN","C0CFM2",65,0)
+ . . S ZZCNT=0
+"RTN","C0CFM2",66,0)
+ . . S ZZC0CI=0
+"RTN","C0CFM2",67,0)
+ . . S ZZVALS=$NA(@C0CMDO@("M")) ; LOCATION OF THIS MULTILPE
+"RTN","C0CFM2",68,0)
+ . . S ZT=$O(@ZZVALS@("")) ; ELEMENT TYPE OF MULTIPLE
+"RTN","C0CFM2",69,0)
+ . . S ZZVALS=$NA(@ZZVALS@(ZT)) ; PAST MULTIPLE TYPE INDICATOR
+"RTN","C0CFM2",70,0)
+ . . W "MULTIPLE:",ZZVALS,!
+"RTN","C0CFM2",71,0)
+ . . ;B
+"RTN","C0CFM2",72,0)
+ . . F  S ZZC0CI=$O(@ZZVALS@(ZZC0CI)) Q:ZZC0CI=""  D  ; EACH MULTIPLE
+"RTN","C0CFM2",73,0)
+ . . . S ZZCNT=ZZCNT+1 ;INCREMENT COUNT
+"RTN","C0CFM2",74,0)
+ . . . W "COUNT:",ZZCNT,!
+"RTN","C0CFM2",75,0)
+ . . . S ZV=$NA(@ZZVALS@(ZZC0CI))
+"RTN","C0CFM2",76,0)
+ . . . D PUTELS(DFN,ZT,C0CX_";"_ZZCNT,ZV)
+"RTN","C0CFM2",77,0)
  Q
-"RTN","C0CFM2",55,0)
- ;
-"RTN","C0CFM2",56,0)
-PUTRIM1(DFN,ZZTYP,ZVARS) ; PUT ONE SECTION OF VARIABLES INTO CCR ELEMENTS
-"RTN","C0CFM2",57,0)
- ; ZVARS IS PASSED BY NAME AN HAS THE FORM @ZVARS@(1,"VAR1")="VAL1"
-"RTN","C0CFM2",58,0)
- S C0CX=0
-"RTN","C0CFM2",59,0)
- F  S C0CX=$O(@ZVARS@(C0CX)) Q:C0CX=""  D  ; FOR EACH OCCURANCE
-"RTN","C0CFM2",60,0)
- . W "ZOCC=",C0CX,!
-"RTN","C0CFM2",61,0)
- . K C0CMDO ; MULTIPLE SUBELEMENTS FOR THIS OCCURANCE PASSED BY NAME
-"RTN","C0CFM2",62,0)
- . S C0CV=$NA(@ZVARS@(C0CX)) ; VARIABLES FOR THIS OCCURANCE
-"RTN","C0CFM2",63,0)
- . D PUTELS(DFN,ZZTYP,C0CX,C0CV) ; PUT THEM TO THE CCR ELEMENTS FILE
-"RTN","C0CFM2",64,0)
- . I $D(C0CMDO) D  ; MULTIPLES TO HANDLE (THIS IS INSTEAD OF RECURSION :()
-"RTN","C0CFM2",65,0)
- . . N ZZCNT,ZZC0CI,ZZVALS,ZT,ZZCNT,ZV
-"RTN","C0CFM2",66,0)
- . . S ZZCNT=0
-"RTN","C0CFM2",67,0)
- . . S ZZC0CI=0
-"RTN","C0CFM2",68,0)
- . . S ZZVALS=$NA(@C0CMDO@("M")) ; LOCATION OF THIS MULTILPE
-"RTN","C0CFM2",69,0)
- . . S ZT=$O(@ZZVALS@("")) ; ELEMENT TYPE OF MULTIPLE
-"RTN","C0CFM2",70,0)
- . . S ZZVALS=$NA(@ZZVALS@(ZT)) ; PAST MULTIPLE TYPE INDICATOR
-"RTN","C0CFM2",71,0)
- . . W "MULTIPLE:",ZZVALS,!
-"RTN","C0CFM2",72,0)
+"RTN","C0CFM2",78,0)
+ ;
+"RTN","C0CFM2",79,0)
+PUTELS(DFN,ZTYPE,ZOCC,ZVALS) ; PUT CCR VALUES INTO THE CCR ELEMENTS FILE
+"RTN","C0CFM2",80,0)
+ ; 171.101, ^C0CE  DFN IS THE PATIENT IEN PASSED BY VALUE
+"RTN","C0CFM2",81,0)
+ ; ZTYPE IS THE NODE TYPE IE RESULTS,PROBLEMS PASSED BY VALUE
+"RTN","C0CFM2",82,0)
+ ; ZOCC IS THE OCCURANCE NUMBER IE PROBLEM NUMBER 1,2,3 ETC
+"RTN","C0CFM2",83,0)
+ ; ZVALS ARE THE VARIABLES AND VALUES PASSED BY NAME AND IN THE FORM
+"RTN","C0CFM2",84,0)
+ ; @ZVALS@("VAR1")="VALUE1" FOR ALL VARIABLES IN THIS ELEMENT
+"RTN","C0CFM2",85,0)
+ ; AND @ZVALS@("M",SUBOCCUR,"VAR2")="VALUE2" FOR SUB VARIABLES
+"RTN","C0CFM2",86,0)
+ ;
+"RTN","C0CFM2",87,0)
+ N PATN,ZTYPN,XD0,ZTYP
+"RTN","C0CFM2",88,0)
+ I '$D(ZSRC) S ZSRC=1 ; CCR SOURCE IS ASSUMED, 1 IF NOT SET
+"RTN","C0CFM2",89,0)
+ ; PUT THIS IN PARAMETERS - SO SOURCE NUMBER FOR PROCESSING IN CONFIGURABLE
+"RTN","C0CFM2",90,0)
+ N C0CFPAT S C0CFPAT=171.101 ; FILE AT PATIENT LEVEL
+"RTN","C0CFM2",91,0)
+ N C0CFSRC S C0CFSRC=171.111 ; FILE AT CCR SOURCE LVL
+"RTN","C0CFM2",92,0)
+ N C0CFTYP S C0CFTYP=171.121 ; FILE AT ELEMENT TYPE LVL
+"RTN","C0CFM2",93,0)
+ N C0CFOCC S C0CFOCC=171.131 ; FILE AT OCCURANCE LVL
+"RTN","C0CFM2",94,0)
+ N C0CFVAR S C0CFVAR=171.1311 ; FILE AT VARIABLE LVL
+"RTN","C0CFM2",95,0)
+ ;FILE IS ^C0CE(PAT,1,SCR,1,TYP,1,OCC,1,VAR,1, ...
+"RTN","C0CFM2",96,0)
+ ; AND WE HAVE TO ADD THEM LEVEL AT A TIME I THINK
+"RTN","C0CFM2",97,0)
+ N C0CFDA
+"RTN","C0CFM2",98,0)
+ S C0CFDA(C0CFPAT,"?+1,",.01)=DFN
+"RTN","C0CFM2",99,0)
+ D UPDIE ; ADD THE PATIENT
+"RTN","C0CFM2",100,0)
+ S PATN=$O(^C0CE("B",DFN,"")) ; IEN FOR THE PATIENT
+"RTN","C0CFM2",101,0)
+ S C0CFDA(C0CFSRC,"?+1,"_PATN_",",.01)=ZSRC
+"RTN","C0CFM2",102,0)
+ D UPDIE ; ADD THE CCR SOURCE
+"RTN","C0CFM2",103,0)
+ N ZTYPN S ZTYPN=$O(^C0CDIC(170.101,"B",ZTYPE,"")) ; FIND THE ELE TYPE
+"RTN","C0CFM2",104,0)
+ S C0CFDA(C0CFTYP,"?+1,"_ZSRC_","_PATN_",",.01)=ZTYPN
+"RTN","C0CFM2",105,0)
+ D UPDIE ; ADD THE ELEMENT TYPE
+"RTN","C0CFM2",106,0)
+ S ZTYP=$O(^C0CE(PATN,1,ZSRC,1,"B",ZTYPN,"")) ; IEN OF ELEMENT TYPE
+"RTN","C0CFM2",107,0)
+ S C0CFDA(C0CFOCC,"?+1,"_ZTYP_","_ZSRC_","_PATN_",",.01)=ZOCC ; STRING OCC
+"RTN","C0CFM2",108,0)
+ ; OCC IS PRECEDED BY " " TO FORCE STRING STORAGE AND PRESERVE
+"RTN","C0CFM2",109,0)
+ ; STRING COLLATION ON THE INDEX
+"RTN","C0CFM2",110,0)
+ D UPDIE ; ADD THE OCCURANCE
+"RTN","C0CFM2",111,0)
+ S ZD0=$O(^C0CE(PATN,1,ZSRC,1,ZTYP,1,"B",ZOCC,""))
+"RTN","C0CFM2",112,0)
+ W "RECORD NUMBER: ",ZD0,!
+"RTN","C0CFM2",113,0)
+ ;I ZD0=32 B
+"RTN","C0CFM2",114,0)
+ ;I ZD0=31 B
+"RTN","C0CFM2",115,0)
+ N ZCNT,ZC0CI,ZVARN,C0CZ1
+"RTN","C0CFM2",116,0)
+ S ZCNT=0
+"RTN","C0CFM2",117,0)
+ S ZC0CI="" ;
+"RTN","C0CFM2",118,0)
+ F  S ZC0CI=$O(@ZVALS@(ZC0CI)) Q:ZC0CI=""  D  ;
+"RTN","C0CFM2",119,0)
+ . I ZC0CI'="M" D  ; NOT A SUBVARIABLE
+"RTN","C0CFM2",120,0)
+ . . S ZCNT=ZCNT+1 ;INCREMENT COUNT
+"RTN","C0CFM2",121,0)
+ . . S ZVARN=$$VARPTR(ZC0CI,ZTYPE) ;GET THE POINTER TO THE VAR IN THE CCR DICT
+"RTN","C0CFM2",122,0)
+ . . ; WILL ALLOW FOR LAYGO IF THE VARIABLE IS NOT FOUND
+"RTN","C0CFM2",123,0)
+ . . S C0CZ1=ZTYP_","_ZSRC_","_PATN_","
+"RTN","C0CFM2",124,0)
+ . . S C0CFDA(C0CFVAR,"?+"_ZCNT_","_ZD0_","_C0CZ1,.01)=ZVARN
+"RTN","C0CFM2",125,0)
+ . . S ZZVAL=$TR(@ZVALS@(ZC0CI),"^","|")
+"RTN","C0CFM2",126,0)
+ . . S C0CFDA(C0CFVAR,"?+"_ZCNT_","_ZD0_","_C0CZ1,1)=ZZVAL
+"RTN","C0CFM2",127,0)
+ . E  D  ; THIS IS A SUBELEMENT
+"RTN","C0CFM2",128,0)
+ . . ;PUT THE FOLLOWING BACK TO USE RECURSION
+"RTN","C0CFM2",129,0)
+ . . ;N ZZCNT,ZZC0CI,ZZVALS,ZT,ZZCNT,ZV
+"RTN","C0CFM2",130,0)
+ . . ;S ZZCNT=0
+"RTN","C0CFM2",131,0)
+ . . ;S ZZC0CI=0
+"RTN","C0CFM2",132,0)
+ . . ;S ZZVALS=$NA(@ZVALS@("M")) ; LOCATION OF THIS MULTILPE
+"RTN","C0CFM2",133,0)
+ . . ;S ZT=$O(@ZZVALS@("")) ; ELEMENT TYPE OF MULTIPLE
+"RTN","C0CFM2",134,0)
+ . . ;S ZZVALS=$NA(@ZZVALS@(ZT)) ; PAST MULTIPLE TYPE INDICATOR
+"RTN","C0CFM2",135,0)
+ . . ;W "MULTIPLE:",ZZVALS,!
+"RTN","C0CFM2",136,0)
  . . ;B
-"RTN","C0CFM2",73,0)
- . . F  S ZZC0CI=$O(@ZZVALS@(ZZC0CI)) Q:ZZC0CI=""  D  ; EACH MULTIPLE
-"RTN","C0CFM2",74,0)
- . . . S ZZCNT=ZZCNT+1 ;INCREMENT COUNT
-"RTN","C0CFM2",75,0)
- . . . W "COUNT:",ZZCNT,!
-"RTN","C0CFM2",76,0)
- . . . S ZV=$NA(@ZZVALS@(ZZC0CI))
-"RTN","C0CFM2",77,0)
- . . . D PUTELS(DFN,ZT,C0CX_";"_ZZCNT,ZV)
-"RTN","C0CFM2",78,0)
+"RTN","C0CFM2",137,0)
+ . . ;F  S ZZC0CI=$O(@ZZVALS@(ZZC0CI)) Q:ZZC0CI=""  D  ; EACH MULTIPLE
+"RTN","C0CFM2",138,0)
+ . . ;. S ZZCNT=ZZCNT+1 ;INCREMENT COUNT
+"RTN","C0CFM2",139,0)
+ . . ;. W "COUNT:",ZZCNT,!
+"RTN","C0CFM2",140,0)
+ . . ;. S ZV=$NA(@ZZVALS@(ZZC0CI))
+"RTN","C0CFM2",141,0)
+ . . ;. D PUTELS(DFN,ZT,ZOCC_";"_ZZCNT,ZV) ; PUT THIS BACK TO DEBUG RECURSION
+"RTN","C0CFM2",142,0)
+ . . S C0CMDO=ZVALS ; FLAG TO HANDLE MULTIPLES (INSTEAD OF RECURSION)
+"RTN","C0CFM2",143,0)
+ D UPDIE ; UPDATE
+"RTN","C0CFM2",144,0)
  Q
-"RTN","C0CFM2",79,0)
- ;
-"RTN","C0CFM2",80,0)
-PUTELS(DFN,ZTYPE,ZOCC,ZVALS) ; PUT CCR VALUES INTO THE CCR ELEMENTS FILE
-"RTN","C0CFM2",81,0)
+"RTN","C0CFM2",145,0)
+ ;
+"RTN","C0CFM2",146,0)
+UPDIE ; INTERNAL ROUTINE TO CALL UPDATE^DIE AND CHECK FOR ERRORS
+"RTN","C0CFM2",147,0)
+ K ZERR
+"RTN","C0CFM2",148,0)
+ D CLEAN^DILF
+"RTN","C0CFM2",149,0)
+ D UPDATE^DIE("","C0CFDA","","ZERR")
+"RTN","C0CFM2",150,0)
+ I $D(ZERR) S $EC=",U1,"
+"RTN","C0CFM2",151,0)
+ K C0CFDA
+"RTN","C0CFM2",152,0)
+ Q
+"RTN","C0CFM2",153,0)
+ ;
+"RTN","C0CFM2",154,0)
+CHECK ; CHECKSUM EXPERIMENTS
+"RTN","C0CFM2",155,0)
+ ;
+"RTN","C0CFM2",156,0)
+ ;B
+"RTN","C0CFM2",157,0)
+ S ZG=$NA(^C0CE(DA(2),1,DA(1),1,DA))
+"RTN","C0CFM2",158,0)
+ ;S G2=$NA(^C0CE(8,1,1,1,2,1,6))
+"RTN","C0CFM2",159,0)
+ S X=$$CHKSUM^XUSESIG1(ZG)
+"RTN","C0CFM2",160,0)
+ W G1,!
+"RTN","C0CFM2",161,0)
+ Q
+"RTN","C0CFM2",162,0)
+ ;
+"RTN","C0CFM2",163,0)
+CHKELS(DFN) ; CHECKSUM ALL ELEMENTS FOR  A PATIENT
+"RTN","C0CFM2",164,0)
+ ;
+"RTN","C0CFM2",165,0)
+ S ZGLB=$NA(^TMP("C0CCHK"))
+"RTN","C0CFM2",166,0)
+ S ZPAT=$O(^C0CE("B",DFN,""))
+"RTN","C0CFM2",167,0)
+ K @ZGLB@(ZPAT) ; CLEAR PREVIOUS CHECKSUMS
+"RTN","C0CFM2",168,0)
+ S ZSRC=""
+"RTN","C0CFM2",169,0)
+ F  S ZSRC=$O(^C0CE(ZPAT,1,"B",ZSRC)) Q:ZSRC=""  D  ;
+"RTN","C0CFM2",170,0)
+ . W "PAT:",ZPAT," SRC:",ZSRC,!
+"RTN","C0CFM2",171,0)
+ . S ZEL=""
+"RTN","C0CFM2",172,0)
+ . F  S ZEL=$O(^C0CE(ZPAT,1,ZSRC,1,"B",ZEL)) Q:ZEL=""  D  ;ELEMENTS
+"RTN","C0CFM2",173,0)
+ . . W "ELEMENT:",ZEL," "
+"RTN","C0CFM2",174,0)
+ . . S ZELE=$$GET1^DIQ(170.101,ZEL,.01,"E") ;ELEMENT NAME
+"RTN","C0CFM2",175,0)
+ . . W ZELE," "
+"RTN","C0CFM2",176,0)
+ . . S ZELI=$O(^C0CE(ZPAT,1,ZSRC,1,"B",ZEL,""))
+"RTN","C0CFM2",177,0)
+ . . S ZG=$NA(^C0CE(ZPAT,1,ZSRC,1,ZELI))
+"RTN","C0CFM2",178,0)
+ . . S ZCHK=$$CHKSUM^XUSESIG1(ZG) ; CHECKSUM FOR THE ELEMENT
+"RTN","C0CFM2",179,0)
+ . . W ZCHK,!
+"RTN","C0CFM2",180,0)
+ . . S @ZGLB@(ZPAT,ZELE,ZSRC)=ZCHK
+"RTN","C0CFM2",181,0)
+ ; ZWR ^TMP("C0CCHK",ZPAT,*)
+"RTN","C0CFM2",182,0)
+ Q
+"RTN","C0CFM2",183,0)
+ ;
+"RTN","C0CFM2",184,0)
+DOIT(DFN) ; EXPERIMENT FOR TIMING CALLS USING mumps -dir DOIT^C0CFM2(DFN)
+"RTN","C0CFM2",185,0)
+ D SETXUP
+"RTN","C0CFM2",186,0)
+ D CHKELS(DFN)
+"RTN","C0CFM2",187,0)
+ Q
+"RTN","C0CFM2",188,0)
+ ;
+"RTN","C0CFM2",189,0)
+SETXUP ; SET UP ENVIRONMENT
+"RTN","C0CFM2",190,0)
+ S DISYS=19
+"RTN","C0CFM2",191,0)
+ S DT=3090325
+"RTN","C0CFM2",192,0)
+ S DTIME=300
+"RTN","C0CFM2",193,0)
+ S DUZ=1
+"RTN","C0CFM2",194,0)
+ S DUZ(0)="@"
+"RTN","C0CFM2",195,0)
+ S DUZ(1)=""
+"RTN","C0CFM2",196,0)
+ S DUZ(2)=7247
+"RTN","C0CFM2",197,0)
+ S DUZ("AG")="I"
+"RTN","C0CFM2",198,0)
+ S DUZ("BUF")=1
+"RTN","C0CFM2",199,0)
+ S DUZ("LANG")=""
+"RTN","C0CFM2",200,0)
+ S IO="/dev/pts/20"
+"RTN","C0CFM2",201,0)
+ S IO(0)="/dev/pts/20"
+"RTN","C0CFM2",202,0)
+ S IO(1,"/dev/pts/20")=""
+"RTN","C0CFM2",203,0)
+ S IO("ERROR")=""
+"RTN","C0CFM2",204,0)
+ S IO("HOME")="344^/dev/pts/20"
+"RTN","C0CFM2",205,0)
+ S IO("ZIO")="/dev/pts/20"
+"RTN","C0CFM2",206,0)
+ S IOBS="$C(8)"
+"RTN","C0CFM2",207,0)
+ S IOF="#,$C(27,91,50,74,27,91,72)"
+"RTN","C0CFM2",208,0)
+ S IOM=80
+"RTN","C0CFM2",209,0)
+ S ION="TELNET"
+"RTN","C0CFM2",210,0)
+ S IOS=344
+"RTN","C0CFM2",211,0)
+ S IOSL=24
+"RTN","C0CFM2",212,0)
+ S IOST="C-VT100"
+"RTN","C0CFM2",213,0)
+ S IOST(0)=9
+"RTN","C0CFM2",214,0)
+ S IOT="VTRM"
+"RTN","C0CFM2",215,0)
+ S IOXY="W $C(27,91)_((DY+1))_$C(59)_((DX+1))_$C(72)"
+"RTN","C0CFM2",216,0)
+ S U="^"
+"RTN","C0CFM2",217,0)
+ S X="216;DIC(4.2,"
+"RTN","C0CFM2",218,0)
+ S XPARSYS="216;DIC(4.2,"
+"RTN","C0CFM2",219,0)
+ S XQXFLG="^^XUP"
+"RTN","C0CFM2",220,0)
+ Q
+"RTN","C0CFM2",221,0)
+ ; 
+"RTN","C0CFM2",222,0)
+PUTELSO(DFN,ZTYPE,ZOCC,ZVALS) ; PUT CCR VALUES INTO THE CCR ELEMENTS FILE
+"RTN","C0CFM2",223,0)
  ; 171.101, ^C0CE  DFN IS THE PATIENT IEN PASSED BY VALUE
-"RTN","C0CFM2",82,0)
+"RTN","C0CFM2",224,0)
  ; ZTYPE IS THE NODE TYPE IE RESULTS,PROBLEMS PASSED BY VALUE
-"RTN","C0CFM2",83,0)
+"RTN","C0CFM2",225,0)
  ; ZOCC IS THE OCCURANCE NUMBER IE PROBLEM NUMBER 1,2,3 ETC
-"RTN","C0CFM2",84,0)
+"RTN","C0CFM2",226,0)
  ; ZVALS ARE THE VARIABLES AND VALUES PASSED BY NAME AND IN THE FORM
-"RTN","C0CFM2",85,0)
+"RTN","C0CFM2",227,0)
  ; @ZVALS@("VAR1")="VALUE1" FOR ALL VARIABLES IN THIS ELEMENT
-"RTN","C0CFM2",86,0)
+"RTN","C0CFM2",228,0)
  ; AND @ZVALS@("M",SUBOCCUR,"VAR2")="VALUE2" FOR SUB VARIABLES
-"RTN","C0CFM2",87,0)
- ;
-"RTN","C0CFM2",88,0)
- N PATN,ZTYPN,XD0,ZTYP
-"RTN","C0CFM2",89,0)
- I '$D(ZSRC) S ZSRC=1 ; CCR SOURCE IS ASSUMED, 1 IF NOT SET
-"RTN","C0CFM2",90,0)
+"RTN","C0CFM2",229,0)
+ ;
+"RTN","C0CFM2",230,0)
+ S ZSRC=1 ; CCR SOURCE IS ASSUMED TO BE THIS EHR, WHICH IS ALWAYS SOURCE 1
+"RTN","C0CFM2",231,0)
  ; PUT THIS IN PARAMETERS - SO SOURCE NUMBER FOR PROCESSING IN CONFIGURABLE
-"RTN","C0CFM2",91,0)
- N C0CFPAT S C0CFPAT=171.101 ; FILE AT PATIENT LEVEL
-"RTN","C0CFM2",92,0)
- N C0CFSRC S C0CFSRC=171.111 ; FILE AT CCR SOURCE LVL
-"RTN","C0CFM2",93,0)
- N C0CFTYP S C0CFTYP=171.121 ; FILE AT ELEMENT TYPE LVL
-"RTN","C0CFM2",94,0)
- N C0CFOCC S C0CFOCC=171.131 ; FILE AT OCCURANCE LVL
-"RTN","C0CFM2",95,0)
- N C0CFVAR S C0CFVAR=171.1311 ; FILE AT VARIABLE LVL
-"RTN","C0CFM2",96,0)
- ;FILE IS ^C0CE(PAT,1,SCR,1,TYP,1,OCC,1,VAR,1, ...
-"RTN","C0CFM2",97,0)
- ; AND WE HAVE TO ADD THEM LEVEL AT A TIME I THINK
-"RTN","C0CFM2",98,0)
- N C0CFDA
-"RTN","C0CFM2",99,0)
- S C0CFDA(C0CFPAT,"?+1,",.01)=DFN
-"RTN","C0CFM2",100,0)
- D UPDIE ; ADD THE PATIENT
-"RTN","C0CFM2",101,0)
- S PATN=$O(^C0CE("B",DFN,"")) ; IEN FOR THE PATIENT
-"RTN","C0CFM2",102,0)
- S C0CFDA(C0CFSRC,"?+1,"_PATN_",",.01)=ZSRC
-"RTN","C0CFM2",103,0)
- D UPDIE ; ADD THE CCR SOURCE
-"RTN","C0CFM2",104,0)
- N ZTYPN S ZTYPN=$O(^C0CDIC(170.101,"B",ZTYPE,"")) ; FIND THE ELE TYPE
-"RTN","C0CFM2",105,0)
- S C0CFDA(C0CFTYP,"?+1,"_ZSRC_","_PATN_",",.01)=ZTYPN
-"RTN","C0CFM2",106,0)
- D UPDIE ; ADD THE ELEMENT TYPE
-"RTN","C0CFM2",107,0)
- S ZTYP=$O(^C0CE(PATN,1,ZSRC,1,"B",ZTYPN,"")) ; IEN OF ELEMENT TYPE
-"RTN","C0CFM2",108,0)
- S C0CFDA(C0CFOCC,"?+1,"_ZTYP_","_ZSRC_","_PATN_",",.01)=ZOCC ; STRING OCC
-"RTN","C0CFM2",109,0)
- ; OCC IS PRECEDED BY " " TO FORCE STRING STORAGE AND PRESERVE
-"RTN","C0CFM2",110,0)
- ; STRING COLLATION ON THE INDEX
-"RTN","C0CFM2",111,0)
- D UPDIE ; ADD THE OCCURANCE
-"RTN","C0CFM2",112,0)
- S ZD0=$O(^C0CE(PATN,1,ZSRC,1,ZTYP,1,"B",ZOCC,""))
-"RTN","C0CFM2",113,0)
+"RTN","C0CFM2",232,0)
+ N ZF,ZFV S ZF=171.101 S ZFV=171.1011
+"RTN","C0CFM2",233,0)
+ ;S ZSUBF=171.20122 ;FILE AND SUBFILE NUMBERS
+"RTN","C0CFM2",234,0)
+ ;N ZSFV S ZSFV=171.201221 ; SUBFILE VARIABLE FILE NUMBER
+"RTN","C0CFM2",235,0)
+ N ZTYPN S ZTYPN=$O(^C0CDIC(170.101,"B",ZTYPE,""))
+"RTN","C0CFM2",236,0)
+ W "ZTYPE: ",ZTYPE," ",ZTYPN,!
+"RTN","C0CFM2",237,0)
+ N ZVARN ; IEN OF VARIABLE BEING PROCESSED
+"RTN","C0CFM2",238,0)
+ ;N C0CFDA ; FDA FOR CCR ELEMENT UPDATE
+"RTN","C0CFM2",239,0)
+ K C0CFDA
+"RTN","C0CFM2",240,0)
+ S C0CFDA(ZF,"?+1,",.01)=DFN
+"RTN","C0CFM2",241,0)
+ S C0CFDA(ZF,"?+1,",.02)=ZSRC
+"RTN","C0CFM2",242,0)
+ S C0CFDA(ZF,"?+1,",.03)=ZTYPN
+"RTN","C0CFM2",243,0)
+ S C0CFDA(ZF,"?+1,",.04)=" "_ZOCC ;CREATE OCCURANCE
+"RTN","C0CFM2",244,0)
+ K ZERR
+"RTN","C0CFM2",245,0)
+ ;B
+"RTN","C0CFM2",246,0)
+ D UPDATE^DIE("","C0CFDA","","ZERR") ;ASSIGN RECORD NUMBER
+"RTN","C0CFM2",247,0)
+ I $D(ZERR) S $EC=",U1,"
+"RTN","C0CFM2",248,0)
+ K C0CFDA
+"RTN","C0CFM2",249,0)
+ S ZD0=$O(^C0CE("C",DFN,ZSRC,ZTYPN,ZOCC,""))
+"RTN","C0CFM2",250,0)
  W "RECORD NUMBER: ",ZD0,!
-"RTN","C0CFM2",114,0)
- ;I ZD0=32 B
-"RTN","C0CFM2",115,0)
- ;I ZD0=31 B
-"RTN","C0CFM2",116,0)
- N ZCNT,ZC0CI,ZVARN,C0CZ1
-"RTN","C0CFM2",117,0)
+"RTN","C0CFM2",251,0)
  S ZCNT=0
-"RTN","C0CFM2",118,0)
+"RTN","C0CFM2",252,0)
  S ZC0CI="" ;
-"RTN","C0CFM2",119,0)
+"RTN","C0CFM2",253,0)
  F  S ZC0CI=$O(@ZVALS@(ZC0CI)) Q:ZC0CI=""  D  ;
-"RTN","C0CFM2",120,0)
+"RTN","C0CFM2",254,0)
  . I ZC0CI'="M" D  ; NOT A SUBVARIABLE
-"RTN","C0CFM2",121,0)
+"RTN","C0CFM2",255,0)
  . . S ZCNT=ZCNT+1 ;INCREMENT COUNT
-"RTN","C0CFM2",122,0)
+"RTN","C0CFM2",256,0)
  . . S ZVARN=$$VARPTR(ZC0CI,ZTYPE) ;GET THE POINTER TO THE VAR IN THE CCR DICT
-"RTN","C0CFM2",123,0)
+"RTN","C0CFM2",257,0)
  . . ; WILL ALLOW FOR LAYGO IF THE VARIABLE IS NOT FOUND
-"RTN","C0CFM2",124,0)
- . . S C0CZ1=ZTYP_","_ZSRC_","_PATN_","
-"RTN","C0CFM2",125,0)
- . . S C0CFDA(C0CFVAR,"?+"_ZCNT_","_ZD0_","_C0CZ1,.01)=ZVARN
-"RTN","C0CFM2",126,0)
- . . S ZZVAL=$TR(@ZVALS@(ZC0CI),"^","|")
-"RTN","C0CFM2",127,0)
- . . S C0CFDA(C0CFVAR,"?+"_ZCNT_","_ZD0_","_C0CZ1,1)=ZZVAL
-"RTN","C0CFM2",128,0)
- . E  D  ; THIS IS A SUBELEMENT
-"RTN","C0CFM2",129,0)
- . . ;PUT THE FOLLOWING BACK TO USE RECURSION
-"RTN","C0CFM2",130,0)
- . . ;N ZZCNT,ZZC0CI,ZZVALS,ZT,ZZCNT,ZV
-"RTN","C0CFM2",131,0)
- . . ;S ZZCNT=0
-"RTN","C0CFM2",132,0)
- . . ;S ZZC0CI=0
-"RTN","C0CFM2",133,0)
- . . ;S ZZVALS=$NA(@ZVALS@("M")) ; LOCATION OF THIS MULTILPE
-"RTN","C0CFM2",134,0)
- . . ;S ZT=$O(@ZZVALS@("")) ; ELEMENT TYPE OF MULTIPLE
-"RTN","C0CFM2",135,0)
- . . ;S ZZVALS=$NA(@ZZVALS@(ZT)) ; PAST MULTIPLE TYPE INDICATOR
-"RTN","C0CFM2",136,0)
- . . ;W "MULTIPLE:",ZZVALS,!
-"RTN","C0CFM2",137,0)
- . . ;B
-"RTN","C0CFM2",138,0)
- . . ;F  S ZZC0CI=$O(@ZZVALS@(ZZC0CI)) Q:ZZC0CI=""  D  ; EACH MULTIPLE
-"RTN","C0CFM2",139,0)
- . . ;. S ZZCNT=ZZCNT+1 ;INCREMENT COUNT
-"RTN","C0CFM2",140,0)
- . . ;. W "COUNT:",ZZCNT,!
-"RTN","C0CFM2",141,0)
- . . ;. S ZV=$NA(@ZZVALS@(ZZC0CI))
-"RTN","C0CFM2",142,0)
- . . ;. D PUTELS(DFN,ZT,ZOCC_";"_ZZCNT,ZV) ; PUT THIS BACK TO DEBUG RECURSION
-"RTN","C0CFM2",143,0)
- . . S C0CMDO=ZVALS ; FLAG TO HANDLE MULTIPLES (INSTEAD OF RECURSION)
-"RTN","C0CFM2",144,0)
- D UPDIE ; UPDATE
-"RTN","C0CFM2",145,0)
+"RTN","C0CFM2",258,0)
+ . . S C0CFDA(ZFV,"?+"_ZCNT_","_ZD0_",",.01)=ZVARN
+"RTN","C0CFM2",259,0)
+ . . S C0CFDA(ZFV,"?+"_ZCNT_","_ZD0_",",1)=@ZVALS@(ZC0CI)
+"RTN","C0CFM2",260,0)
+ . . ;S C0CFDA(ZSFV,"+1,"_DFN_","_ZSRC_","_ZTYPN_","_ZOCC_",",.01)=ZVARN
+"RTN","C0CFM2",261,0)
+ . . ;S C0CFDA(ZSFV,"+1,"_DFN_","_ZSRC_","_ZTYPN_","_ZOCC_",",1)=@ZVALS@(ZC0CI)
+"RTN","C0CFM2",262,0)
+ ;S GT1(170,"?+1,",.01)="ZZZ NEW MEDVEHICLETEXT"
+"RTN","C0CFM2",263,0)
+ ;S GT1(170,"?+1,",12)="DIR"
+"RTN","C0CFM2",264,0)
+ ;S GT1(171.201221,"?+1,1,5,1,",.01)="ZZZ NEW MEDVEHICLETEXT"
+"RTN","C0CFM2",265,0)
+ ;S GT1(171.201221,"+1,1,5,1,",1)="THIRD NEW MED DIRECTION TEXT"
+"RTN","C0CFM2",266,0)
+ D CLEAN^DILF
+"RTN","C0CFM2",267,0)
+ D UPDATE^DIE("","C0CFDA","","ZERR")
+"RTN","C0CFM2",268,0)
+ I $D(ZERR) S $EC=",U1,"
+"RTN","C0CFM2",269,0)
+ K C0CFDA
+"RTN","C0CFM2",270,0)
  Q
-"RTN","C0CFM2",146,0)
- ;
-"RTN","C0CFM2",147,0)
-UPDIE ; INTERNAL ROUTINE TO CALL UPDATE^DIE AND CHECK FOR ERRORS
-"RTN","C0CFM2",148,0)
- K ZERR
-"RTN","C0CFM2",149,0)
- D CLEAN^DILF
-"RTN","C0CFM2",150,0)
- D UPDATE^DIE("","C0CFDA","","ZERR")
-"RTN","C0CFM2",151,0)
- I $D(ZERR) D  ;
-"RTN","C0CFM2",152,0)
- . W "ERROR",!
-"RTN","C0CFM2",153,0)
- . ZWR ZERR
-"RTN","C0CFM2",154,0)
- . B
-"RTN","C0CFM2",155,0)
- K C0CFDA
-"RTN","C0CFM2",156,0)
+"RTN","C0CFM2",271,0)
+ ;
+"RTN","C0CFM2",272,0)
+VARPTR(ZVAR,ZTYP) ;EXTRINSIC WHICH RETURNS THE POINTER TO ZVAR IN THE
+"RTN","C0CFM2",273,0)
+ ; CCR DICTIONARY. IT IS LAYGO, AS IT WILL ADD THE VARIABLE TO
+"RTN","C0CFM2",274,0)
+ ; THE CCR DICTIONARY IF IT IS NOT THERE. ZTYP IS REQUIRED FOR LAYGO
+"RTN","C0CFM2",275,0)
+ ;
+"RTN","C0CFM2",276,0)
+ N ZCCRD,ZVARN,C0CFDA2
+"RTN","C0CFM2",277,0)
+ S ZCCRD=170 ; FILE NUMBER FOR CCR DICTIONARY
+"RTN","C0CFM2",278,0)
+ S ZVARN=$O(^C0CDIC(170,"B",ZVAR,"")) ;FIND IEN OF VARIABLE
+"RTN","C0CFM2",279,0)
+ I ZVARN="" D  ; VARIABLE NOT IN CCR DICTIONARY - ADD IT
+"RTN","C0CFM2",280,0)
+ . I '$D(ZTYP) D  Q  ; WON'T ADD A VARIABLE WITHOUT A TYPE
+"RTN","C0CFM2",281,0)
+ . . W "CANNOT ADD VARIABLE WITHOUT A TYPE: ",ZVAR,!
+"RTN","C0CFM2",282,0)
+ . S C0CFDA2(ZCCRD,"?+1,",.01)=ZVAR ; NAME OF NEW VARIABLE
+"RTN","C0CFM2",283,0)
+ . S C0CFDA2(ZCCRD,"?+1,",12)=ZTYP ; TYPE EXTERNAL OF NEW VARIABLE
+"RTN","C0CFM2",284,0)
+ . D CLEAN^DILF ;MAKE SURE ERRORS ARE CLEAN
+"RTN","C0CFM2",285,0)
+ . D UPDATE^DIE("E","C0CFDA2","","ZERR") ;ADD VAR TO CCR DICTIONARY
+"RTN","C0CFM2",286,0)
+ . I $D(ZERR) D  ; LAYGO ERROR
+"RTN","C0CFM2",287,0)
+ . . W "ERROR ADDING "_ZC0CI_" TO CCR DICTIONARY",!
+"RTN","C0CFM2",288,0)
+ . E  D  ;
+"RTN","C0CFM2",289,0)
+ . . D CLEAN^DILF ; CLEAN UP
+"RTN","C0CFM2",290,0)
+ . . S ZVARN=$O(^C0CDIC(170,"B",ZVAR,"")) ;FIND IEN OF VARIABLE
+"RTN","C0CFM2",291,0)
+ . . W "ADDED ",ZVAR," TO CCR DICTIONARY, IEN:",ZVARN,!
+"RTN","C0CFM2",292,0)
+ Q ZVARN
+"RTN","C0CFM2",293,0)
+ ;
+"RTN","C0CFM2",294,0)
+BLDTYPS ; ROUTINE TO POPULATE THE CCR NODE TYPES FILE (^C0CDIC(170.101,)
+"RTN","C0CFM2",295,0)
+ ; THE CCR DICTIONARY (^C0CDIC(170, ) HAS MOST OF WHAT'S NEEDED
+"RTN","C0CFM2",296,0)
+ ;
+"RTN","C0CFM2",297,0)
+ N C0CDIC,C0CNODE ;
+"RTN","C0CFM2",298,0)
+ S C0CDIC=$$FILEREF^C0CRNF(170) ; CLOSED FILE REFERENCE TO THE CCR DICTIONARY
+"RTN","C0CFM2",299,0)
+ S C0CNODE=$$FILEREF^C0CRNF(170.101) ; CLOSED REF TO CCR NODE TYPE FILE
+"RTN","C0CFM2",300,0)
  Q
-"RTN","C0CFM2",157,0)
- ;
-"RTN","C0CFM2",158,0)
-CHECK ; CHECKSUM EXPERIMENTS
-"RTN","C0CFM2",159,0)
- ;
-"RTN","C0CFM2",160,0)
- ;B
-"RTN","C0CFM2",161,0)
- S ZG=$NA(^C0CE(DA(2),1,DA(1),1,DA))
-"RTN","C0CFM2",162,0)
- ;S G2=$NA(^C0CE(8,1,1,1,2,1,6))
-"RTN","C0CFM2",163,0)
- S X=$$CHKSUM^XUSESIG1(ZG)
-"RTN","C0CFM2",164,0)
- W G1,!
-"RTN","C0CFM2",165,0)
+"RTN","C0CFM2",301,0)
+ ;
+"RTN","C0CFM2",302,0)
+FIXSEC ;FIX THE SECTION FIELD OF THE CCR DICTIONARY.. IT HAS BEEN REDEFINED
+"RTN","C0CFM2",303,0)
+ ; AS A POINTER TO CCR NODE TYPE INSTEAD OF BEING A SET
+"RTN","C0CFM2",304,0)
+ ; THE SET VALUES ARE PRESERVED IN ^KBAI("SECTION") TO FACILITATE THIS
+"RTN","C0CFM2",305,0)
+ ; CONVERSION
+"RTN","C0CFM2",306,0)
+ ;N C0CC,C0CI,C0CJ,C0CN,C0CZX
+"RTN","C0CFM2",307,0)
+ D FIELDS^C0CRNF("C0CC",170)
+"RTN","C0CFM2",308,0)
+ S C0CI=""
+"RTN","C0CFM2",309,0)
+ F  S C0CI=$O(^KBAI("SECTION",C0CI)) Q:C0CI=""  D  ; EACH SECTION
+"RTN","C0CFM2",310,0)
+ . S C0CZX=""
+"RTN","C0CFM2",311,0)
+ . F  S C0CZX=$O(^KBAI("SECTION",C0CI,C0CZX)) Q:C0CZX=""  D  ; EACH VARIABLE
+"RTN","C0CFM2",312,0)
+ . . W "SECTION ",C0CI," VAR ",C0CZX
+"RTN","C0CFM2",313,0)
+ . . S C0CV=$O(^C0CDIC(170.101,"B",C0CI,""))
+"RTN","C0CFM2",314,0)
+ . . W " TYPE: ",C0CV,!
+"RTN","C0CFM2",315,0)
+ . . D SETFDA("SECTION",C0CV)
+"RTN","C0CFM2",316,0)
+ . . ;ZWR C0CFDA
+"RTN","C0CFM2",317,0)
  Q
-"RTN","C0CFM2",166,0)
- ;
-"RTN","C0CFM2",167,0)
-CHKELS(DFN) ; CHECKSUM ALL ELEMENTS FOR  A PATIENT
-"RTN","C0CFM2",168,0)
- ;
-"RTN","C0CFM2",169,0)
- S ZGLB=$NA(^TMP("C0CCHK"))
-"RTN","C0CFM2",170,0)
- S ZPAT=$O(^C0CE("B",DFN,""))
-"RTN","C0CFM2",171,0)
- K @ZGLB@(ZPAT) ; CLEAR PREVIOUS CHECKSUMS
-"RTN","C0CFM2",172,0)
- S ZSRC=""
-"RTN","C0CFM2",173,0)
- F  S ZSRC=$O(^C0CE(ZPAT,1,"B",ZSRC)) Q:ZSRC=""  D  ;
-"RTN","C0CFM2",174,0)
- . W "PAT:",ZPAT," SRC:",ZSRC,!
-"RTN","C0CFM2",175,0)
- . S ZEL=""
-"RTN","C0CFM2",176,0)
- . F  S ZEL=$O(^C0CE(ZPAT,1,ZSRC,1,"B",ZEL)) Q:ZEL=""  D  ;ELEMENTS
-"RTN","C0CFM2",177,0)
- . . W "ELEMENT:",ZEL," "
-"RTN","C0CFM2",178,0)
- . . S ZELE=$$GET1^DIQ(170.101,ZEL,.01,"E") ;ELEMENT NAME
-"RTN","C0CFM2",179,0)
- . . W ZELE," "
-"RTN","C0CFM2",180,0)
- . . S ZELI=$O(^C0CE(ZPAT,1,ZSRC,1,"B",ZEL,""))
-"RTN","C0CFM2",181,0)
- . . S ZG=$NA(^C0CE(ZPAT,1,ZSRC,1,ZELI))
-"RTN","C0CFM2",182,0)
- . . S ZCHK=$$CHKSUM^XUSESIG1(ZG) ; CHECKSUM FOR THE ELEMENT
-"RTN","C0CFM2",183,0)
- . . W ZCHK,!
-"RTN","C0CFM2",184,0)
- . . S @ZGLB@(ZPAT,ZELE,ZSRC)=ZCHK
-"RTN","C0CFM2",185,0)
- ZWR ^TMP("C0CCHK",ZPAT,*)
-"RTN","C0CFM2",186,0)
+"RTN","C0CFM2",318,0)
+ ;
+"RTN","C0CFM2",319,0)
+SETFDA(C0CSN,C0CSV) ; INTERNAL ROUTINE TO MAKE AN FDA ENTRY FOR FIELD C0CSN
+"RTN","C0CFM2",320,0)
+ ; TO SET TO VALUE C0CSV.
+"RTN","C0CFM2",321,0)
+ ; C0CFDA,C0CC,C0CZX ARE ASSUMED FROM THE CALLING ROUTINE
+"RTN","C0CFM2",322,0)
+ ; C0CSN,C0CSV ARE PASSED BY VALUE
+"RTN","C0CFM2",323,0)
+ ;
+"RTN","C0CFM2",324,0)
+ N C0CSI,C0CSJ
+"RTN","C0CFM2",325,0)
+ S C0CSI=$$ZFILE(C0CSN,"C0CC") ; FILE NUMBER
+"RTN","C0CFM2",326,0)
+ S C0CSJ=$$ZFIELD(C0CSN,"C0CC") ; FIELD NUMBER
+"RTN","C0CFM2",327,0)
+ S C0CFDA(C0CSI,C0CZX_",",C0CSJ)=C0CSV
+"RTN","C0CFM2",328,0)
  Q
-"RTN","C0CFM2",187,0)
- ;
-"RTN","C0CFM2",188,0)
-DOIT(DFN) ; EXPERIMENT FOR TIMING CALLS USING mumps -dir DOIT^C0CFM2(DFN)
-"RTN","C0CFM2",189,0)
- D SETXUP
-"RTN","C0CFM2",190,0)
- D CHKELS(DFN)
-"RTN","C0CFM2",191,0)
- Q
-"RTN","C0CFM2",192,0)
- ;
-"RTN","C0CFM2",193,0)
-SETXUP ; SET UP ENVIRONMENT
-"RTN","C0CFM2",194,0)
- S DISYS=19
-"RTN","C0CFM2",195,0)
- S DT=3090325
-"RTN","C0CFM2",196,0)
- S DTIME=300
-"RTN","C0CFM2",197,0)
- S DUZ=1
-"RTN","C0CFM2",198,0)
- S DUZ(0)="@"
-"RTN","C0CFM2",199,0)
- S DUZ(1)=""
-"RTN","C0CFM2",200,0)
- S DUZ(2)=7247
-"RTN","C0CFM2",201,0)
- S DUZ("AG")="I"
-"RTN","C0CFM2",202,0)
- S DUZ("BUF")=1
-"RTN","C0CFM2",203,0)
- S DUZ("LANG")=""
-"RTN","C0CFM2",204,0)
- S IO="/dev/pts/20"
-"RTN","C0CFM2",205,0)
- S IO(0)="/dev/pts/20"
-"RTN","C0CFM2",206,0)
- S IO(1,"/dev/pts/20")=""
-"RTN","C0CFM2",207,0)
- S IO("ERROR")=""
-"RTN","C0CFM2",208,0)
- S IO("HOME")="344^/dev/pts/20"
-"RTN","C0CFM2",209,0)
- S IO("ZIO")="/dev/pts/20"
-"RTN","C0CFM2",210,0)
- S IOBS="$C(8)"
-"RTN","C0CFM2",211,0)
- S IOF="#,$C(27,91,50,74,27,91,72)"
-"RTN","C0CFM2",212,0)
- S IOM=80
-"RTN","C0CFM2",213,0)
- S ION="TELNET"
-"RTN","C0CFM2",214,0)
- S IOS=344
-"RTN","C0CFM2",215,0)
- S IOSL=24
-"RTN","C0CFM2",216,0)
- S IOST="C-VT100"
-"RTN","C0CFM2",217,0)
- S IOST(0)=9
-"RTN","C0CFM2",218,0)
- S IOT="VTRM"
-"RTN","C0CFM2",219,0)
- S IOXY="W $C(27,91)_((DY+1))_$C(59)_((DX+1))_$C(72)"
-"RTN","C0CFM2",220,0)
- S U="^"
-"RTN","C0CFM2",221,0)
- S X="216;DIC(4.2,"
-"RTN","C0CFM2",222,0)
- S XPARSYS="216;DIC(4.2,"
-"RTN","C0CFM2",223,0)
- S XQXFLG="^^XUP"
-"RTN","C0CFM2",224,0)
- Q
-"RTN","C0CFM2",225,0)
- ; 
-"RTN","C0CFM2",226,0)
-PUTELSOLD(DFN,ZTYPE,ZOCC,ZVALS) ; PUT CCR VALUES INTO THE CCR ELEMENTS FILE
-"RTN","C0CFM2",227,0)
- ; 171.101, ^C0CE  DFN IS THE PATIENT IEN PASSED BY VALUE
-"RTN","C0CFM2",228,0)
- ; ZTYPE IS THE NODE TYPE IE RESULTS,PROBLEMS PASSED BY VALUE
-"RTN","C0CFM2",229,0)
- ; ZOCC IS THE OCCURANCE NUMBER IE PROBLEM NUMBER 1,2,3 ETC
-"RTN","C0CFM2",230,0)
- ; ZVALS ARE THE VARIABLES AND VALUES PASSED BY NAME AND IN THE FORM
-"RTN","C0CFM2",231,0)
- ; @ZVALS@("VAR1")="VALUE1" FOR ALL VARIABLES IN THIS ELEMENT
-"RTN","C0CFM2",232,0)
- ; AND @ZVALS@("M",SUBOCCUR,"VAR2")="VALUE2" FOR SUB VARIABLES
-"RTN","C0CFM2",233,0)
- ;
-"RTN","C0CFM2",234,0)
- S ZSRC=1 ; CCR SOURCE IS ASSUMED TO BE THIS EHR, WHICH IS ALWAYS SOURCE 1
-"RTN","C0CFM2",235,0)
- ; PUT THIS IN PARAMETERS - SO SOURCE NUMBER FOR PROCESSING IN CONFIGURABLE
-"RTN","C0CFM2",236,0)
- N ZF,ZFV S ZF=171.101 S ZFV=171.1011
-"RTN","C0CFM2",237,0)
- ;S ZSUBF=171.20122 ;FILE AND SUBFILE NUMBERS
-"RTN","C0CFM2",238,0)
- ;N ZSFV S ZSFV=171.201221 ; SUBFILE VARIABLE FILE NUMBER
-"RTN","C0CFM2",239,0)
- N ZTYPN S ZTYPN=$O(^C0CDIC(170.101,"B",ZTYPE,""))
-"RTN","C0CFM2",240,0)
- W "ZTYPE: ",ZTYPE," ",ZTYPN,!
-"RTN","C0CFM2",241,0)
- N ZVARN ; IEN OF VARIABLE BEING PROCESSED
-"RTN","C0CFM2",242,0)
- ;N C0CFDA ; FDA FOR CCR ELEMENT UPDATE
-"RTN","C0CFM2",243,0)
- K C0CFDA
-"RTN","C0CFM2",244,0)
- S C0CFDA(ZF,"?+1,",.01)=DFN
-"RTN","C0CFM2",245,0)
- S C0CFDA(ZF,"?+1,",.02)=ZSRC
-"RTN","C0CFM2",246,0)
- S C0CFDA(ZF,"?+1,",.03)=ZTYPN
-"RTN","C0CFM2",247,0)
- S C0CFDA(ZF,"?+1,",.04)=" "_ZOCC ;CREATE OCCURANCE
-"RTN","C0CFM2",248,0)
- K ZERR
-"RTN","C0CFM2",249,0)
- ;B
-"RTN","C0CFM2",250,0)
- D UPDATE^DIE("","C0CFDA","","ZERR") ;ASSIGN RECORD NUMBER
-"RTN","C0CFM2",251,0)
- I $D(ZERR) B  ;OOPS
-"RTN","C0CFM2",252,0)
- K C0CFDA
-"RTN","C0CFM2",253,0)
- S ZD0=$O(^C0CE("C",DFN,ZSRC,ZTYPN,ZOCC,""))
-"RTN","C0CFM2",254,0)
- W "RECORD NUMBER: ",ZD0,!
-"RTN","C0CFM2",255,0)
- ;B
-"RTN","C0CFM2",256,0)
- S ZCNT=0
-"RTN","C0CFM2",257,0)
- S ZC0CI="" ;
-"RTN","C0CFM2",258,0)
- F  S ZC0CI=$O(@ZVALS@(ZC0CI)) Q:ZC0CI=""  D  ;
-"RTN","C0CFM2",259,0)
- . I ZC0CI'="M" D  ; NOT A SUBVARIABLE
-"RTN","C0CFM2",260,0)
- . . S ZCNT=ZCNT+1 ;INCREMENT COUNT
-"RTN","C0CFM2",261,0)
- . . S ZVARN=$$VARPTR(ZC0CI,ZTYPE) ;GET THE POINTER TO THE VAR IN THE CCR DICT
-"RTN","C0CFM2",262,0)
- . . ; WILL ALLOW FOR LAYGO IF THE VARIABLE IS NOT FOUND
-"RTN","C0CFM2",263,0)
- . . S C0CFDA(ZFV,"?+"_ZCNT_","_ZD0_",",.01)=ZVARN
-"RTN","C0CFM2",264,0)
- . . S C0CFDA(ZFV,"?+"_ZCNT_","_ZD0_",",1)=@ZVALS@(ZC0CI)
-"RTN","C0CFM2",265,0)
- . . ;S C0CFDA(ZSFV,"+1,"_DFN_","_ZSRC_","_ZTYPN_","_ZOCC_",",.01)=ZVARN
-"RTN","C0CFM2",266,0)
- . . ;S C0CFDA(ZSFV,"+1,"_DFN_","_ZSRC_","_ZTYPN_","_ZOCC_",",1)=@ZVALS@(ZC0CI)
-"RTN","C0CFM2",267,0)
- ;S GT1(170,"?+1,",.01)="ZZZ NEW MEDVEHICLETEXT"
-"RTN","C0CFM2",268,0)
- ;S GT1(170,"?+1,",12)="DIR"
-"RTN","C0CFM2",269,0)
- ;S GT1(171.201221,"?+1,1,5,1,",.01)="ZZZ NEW MEDVEHICLETEXT"
-"RTN","C0CFM2",270,0)
- ;S GT1(171.201221,"+1,1,5,1,",1)="THIRD NEW MED DIRECTION TEXT"
-"RTN","C0CFM2",271,0)
- D CLEAN^DILF
-"RTN","C0CFM2",272,0)
- D UPDATE^DIE("","C0CFDA","","ZERR")
-"RTN","C0CFM2",273,0)
- I $D(ZERR) D  ;
-"RTN","C0CFM2",274,0)
- . W "ERROR",!
-"RTN","C0CFM2",275,0)
- . ZWR ZERR
-"RTN","C0CFM2",276,0)
- . B
-"RTN","C0CFM2",277,0)
- K C0CFDA
-"RTN","C0CFM2",278,0)
- Q
-"RTN","C0CFM2",279,0)
- ;
-"RTN","C0CFM2",280,0)
-VARPTR(ZVAR,ZTYP) ;EXTRINSIC WHICH RETURNS THE POINTER TO ZVAR IN THE
-"RTN","C0CFM2",281,0)
- ; CCR DICTIONARY. IT IS LAYGO, AS IT WILL ADD THE VARIABLE TO
-"RTN","C0CFM2",282,0)
- ; THE CCR DICTIONARY IF IT IS NOT THERE. ZTYP IS REQUIRED FOR LAYGO
-"RTN","C0CFM2",283,0)
- ;
-"RTN","C0CFM2",284,0)
- N ZCCRD,ZVARN,C0CFDA2
-"RTN","C0CFM2",285,0)
- S ZCCRD=170 ; FILE NUMBER FOR CCR DICTIONARY
-"RTN","C0CFM2",286,0)
- S ZVARN=$O(^C0CDIC(170,"B",ZVAR,"")) ;FIND IEN OF VARIABLE
-"RTN","C0CFM2",287,0)
- I ZVARN="" D  ; VARIABLE NOT IN CCR DICTIONARY - ADD IT
-"RTN","C0CFM2",288,0)
- . I '$D(ZTYP) D  Q  ; WON'T ADD A VARIABLE WITHOUT A TYPE
-"RTN","C0CFM2",289,0)
- . . W "CANNOT ADD VARIABLE WITHOUT A TYPE: ",ZVAR,!
-"RTN","C0CFM2",290,0)
- . S C0CFDA2(ZCCRD,"?+1,",.01)=ZVAR ; NAME OF NEW VARIABLE
-"RTN","C0CFM2",291,0)
- . S C0CFDA2(ZCCRD,"?+1,",12)=ZTYP ; TYPE EXTERNAL OF NEW VARIABLE
-"RTN","C0CFM2",292,0)
- . D CLEAN^DILF ;MAKE SURE ERRORS ARE CLEAN
-"RTN","C0CFM2",293,0)
- . D UPDATE^DIE("E","C0CFDA2","","ZERR") ;ADD VAR TO CCR DICTIONARY
-"RTN","C0CFM2",294,0)
- . I $D(ZERR) D  ; LAYGO ERROR
-"RTN","C0CFM2",295,0)
- . . W "ERROR ADDING "_ZC0CI_" TO CCR DICTIONARY",!
-"RTN","C0CFM2",296,0)
- . E  D  ;
-"RTN","C0CFM2",297,0)
- . . D CLEAN^DILF ; CLEAN UP
-"RTN","C0CFM2",298,0)
- . . S ZVARN=$O(^C0CDIC(170,"B",ZVAR,"")) ;FIND IEN OF VARIABLE
-"RTN","C0CFM2",299,0)
- . . W "ADDED ",ZVAR," TO CCR DICTIONARY, IEN:",ZVARN,!
-"RTN","C0CFM2",300,0)
- Q ZVARN
-"RTN","C0CFM2",301,0)
- ;
-"RTN","C0CFM2",302,0)
-BLDTYPS ; ROUTINE TO POPULATE THE CCR NODE TYPES FILE (^C0CDIC(170.101,)
-"RTN","C0CFM2",303,0)
- ; THE CCR DICTIONARY (^C0CDIC(170, ) HAS MOST OF WHAT'S NEEDED
-"RTN","C0CFM2",304,0)
- ;
-"RTN","C0CFM2",305,0)
- N C0CDIC,C0CNODE ;
-"RTN","C0CFM2",306,0)
- S C0CDIC=$$FILEREF^C0CRNF(170) ; CLOSED FILE REFERENCE TO THE CCR DICTIONARY
-"RTN","C0CFM2",307,0)
- S C0CNODE=$$FILEREF^C0CRNF(170.101) ; CLOSED REF TO CCR NODE TYPE FILE
-"RTN","C0CFM2",308,0)
- Q
-"RTN","C0CFM2",309,0)
- ;
-"RTN","C0CFM2",310,0)
-FIXSEC ;FIX THE SECTION FIELD OF THE CCR DICTIONARY.. IT HAS BEEN REDEFINED
-"RTN","C0CFM2",311,0)
- ; AS A POINTER TO CCR NODE TYPE INSTEAD OF BEING A SET
-"RTN","C0CFM2",312,0)
- ; THE SET VALUES ARE PRESERVED IN ^KBAI("SECTION") TO FACILITATE THIS
-"RTN","C0CFM2",313,0)
- ; CONVERSION
-"RTN","C0CFM2",314,0)
- ;N C0CC,C0CI,C0CJ,C0CN,C0CZX
-"RTN","C0CFM2",315,0)
- D FIELDS^C0CRNF("C0CC",170)
-"RTN","C0CFM2",316,0)
- S C0CI=""
-"RTN","C0CFM2",317,0)
- F  S C0CI=$O(^KBAI("SECTION",C0CI)) Q:C0CI=""  D  ; EACH SECTION
-"RTN","C0CFM2",318,0)
- . S C0CZX=""
-"RTN","C0CFM2",319,0)
- . F  S C0CZX=$O(^KBAI("SECTION",C0CI,C0CZX)) Q:C0CZX=""  D  ; EACH VARIABLE
-"RTN","C0CFM2",320,0)
- . . W "SECTION ",C0CI," VAR ",C0CZX
-"RTN","C0CFM2",321,0)
- . . S C0CV=$O(^C0CDIC(170.101,"B",C0CI,""))
-"RTN","C0CFM2",322,0)
- . . W " TYPE: ",C0CV,!
-"RTN","C0CFM2",323,0)
- . . D SETFDA("SECTION",C0CV)
-"RTN","C0CFM2",324,0)
- . . ;ZWR C0CFDA
-"RTN","C0CFM2",325,0)
- Q
-"RTN","C0CFM2",326,0)
- ;
-"RTN","C0CFM2",327,0)
-SETFDA(C0CSN,C0CSV) ; INTERNAL ROUTINE TO MAKE AN FDA ENTRY FOR FIELD C0CSN
-"RTN","C0CFM2",328,0)
- ; TO SET TO VALUE C0CSV.
 "RTN","C0CFM2",329,0)
- ; C0CFDA,C0CC,C0CZX ARE ASSUMED FROM THE CALLING ROUTINE
+ZFILE(ZFN,ZTAB) ; EXTRINSIC TO RETURN FILE NUMBER FOR FIELD NAME PASSED
 "RTN","C0CFM2",330,0)
- ; C0CSN,C0CSV ARE PASSED BY VALUE
+ ; BY VALUE IN ZFN. FILE NUMBER IS PIECE 1 OF C0CA(ZFN)
 "RTN","C0CFM2",331,0)
- ;
+ ; IF ZTAB IS NULL, IT DEFAULTS TO C0CA
 "RTN","C0CFM2",332,0)
- N C0CSI,C0CSJ
+ I '$D(ZTAB) S ZTAB="C0CA"
 "RTN","C0CFM2",333,0)
- S C0CSI=$$ZFILE(C0CSN,"C0CC") ; FILE NUMBER
+ N ZR
 "RTN","C0CFM2",334,0)
- S C0CSJ=$$ZFIELD(C0CSN,"C0CC") ; FIELD NUMBER
+ I $D(@ZTAB@(ZFN)) S ZR=$P(@ZTAB@(ZFN),"^",1)
 "RTN","C0CFM2",335,0)
- S C0CFDA(C0CSI,C0CZX_",",C0CSJ)=C0CSV
+ E  S ZR=""
 "RTN","C0CFM2",336,0)
- Q
+ Q ZR
 "RTN","C0CFM2",337,0)
-ZFILE(ZFN,ZTAB) ; EXTRINSIC TO RETURN FILE NUMBER FOR FIELD NAME PASSED
+ZFIELD(ZFN,ZTAB) ;EXTRINSIC TO RETURN FIELD NUMBER FOR FIELD NAME PASSED
 "RTN","C0CFM2",338,0)
- ; BY VALUE IN ZFN. FILE NUMBER IS PIECE 1 OF C0CA(ZFN)
+ ; BY VALUE IN ZFN. FILE NUMBER IS PIECE 2 OF C0CA(ZFN)
 "RTN","C0CFM2",339,0)
  ; IF ZTAB IS NULL, IT DEFAULTS TO C0CA
